;------------------------------------------------------------------
      .586
      .model flat, stdcall
      option casemap :none   ; case sensitive

      include \masm32\include\windows.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include aplib.inc

      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib aplib.lib
;------------------------------------------------------------------
      WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
      WndProc2 PROTO :DWORD,:DWORD,:DWORD,:DWORD
      WndProc3 PROTO :DWORD,:DWORD,:DWORD,:DWORD

      GetExeFile PROTO
      UnmapFile PROTO
      MapFile PROTO :DWORD
      ResizeMapFile PROTO :DWORD,:DWORD
      ConvertFO2VA PROTO :DWORD,:DWORD
      ConvertVA2FO PROTO :DWORD,:DWORD
      GetSectionNumber PROTO :DWORD,:DWORD
      IsSectionPackable PROTO :DWORD,:DWORD
      CreateOutFile PROTO :DWORD
      CloseOutFile PROTO
      WriteData PROTO :DWORD,:DWORD
      cProgress PROTO C :DWORD,:DWORD,:DWORD,:DWORD
      lProgress PROTO :DWORD
      ExtractOverlay PROTO :DWORD,:DWORD
      AddOverlay PROTO :DWORD,:DWORD
      CompressSection PROTO :DWORD,:DWORD,:DWORD
      FindMainIcon PROTO
      FilterCode PROTO :DWORD,:DWORD,:DWORD
      CompressRelocations PROTO :DWORD,:DWORD
      SortRelocations PROTO :DWORD,:DWORD
      IsDLLNameAdded PROTO :DWORD,:DWORD
;------------------------------------------------------------------
 .data
    	szTMP db "Overlay.ovl",0h

	dlgname db "TESTWIN",0
	dlgname2 db "TESTWIN2",0
	dlgname3 db "TESTWIN3",0
	dlgTitle db "RLPack - BasicEdition",0h
	dlgTitle2 db "RLPack - About",0h
	dlgTitle3 db "RLPack - Resource options",0h
 ;
 ; Promenljive za About dialog
 ;
	szMyWebSite db "http://www.reversinglabs.com",0h
	szMyUpdate db "http://www.reversinglabs.com/download.html",0h
 ;
 ; Promenljive za OpenFileName dialog
 ;
	ofn OPENFILENAME <>
	FilterString db "All .exe Files",0,"*.exe",0h,"All .dll Files",0,"*.dll",0h,"All Files",0,"*.*",0h,0h
	OurTitle db "RLPack - BasicEdition",0h
	szCHM db "help.chm",0h
 ;
 ; Razno
 ;
	szPackedExe db ".bak",0h
	szSN_text db ".text",0h
	szSN_code db "CODE",0h
	szSN_Ddata db "DATA",0h
	szSN_bss db "BSS",0h
	szSN_tls db ".tls",0h
	szSN_data db ".data",0h
	szSN_rdata db ".rdata",0h
	szSN_idata db ".idata",0h
	szSN_edata db ".edata",0h
	szSN_rsrc db ".rsrc",0h
	szSN_reloc db ".reloc",0h
	
	szTYPELIB db "T",0,"Y",0,"P",0,"E",0,"L",0,"I",0,"B",0,0,0

	comma db ",",0h
	szRSRCPackFormat db "%X,",0h
 ;
 ; Messages
 ;
	szInfo_Version db " RLPack Basic Edition 1.21, (c)2008 by Reversing Labs",0h
	szInfo_UserName db " Licensed to: PUBLIC",0h
	szInfo_License1 db " License type: GPL 2.0",0h

	OSize_format db "Original size: %d bytes",0h
	PSize_format db "Packed size: %d bytes",0h
	Ratio_format db "Ratio: %d percent",0h

	szOpen db "open",0h
	WebSite db "http://www.reversinglabs.com/buy.html",0h

	szPackStart db "Packing started...",0h
	szLoadIat db "Loading IAT",0h
	szPackingSections db "Packing sections",0h
	szPackingResources db "Packing resources",0h
	szPackingExport db "Packing export table",0h
	szFilePacked db "File has been packed!",0h
	szSaveOverlay db "Saving overlay",0h
	szPackEnded db "Packing ended...",0h
	szUnpackable db "File can not be packed!",0h
	szAbout db "About",0h
	szWarningTitle db "Warning:",0h
	szStripTLS db "Stripping TLS may cause application to crash or not work at all! Do you want to leave this option ON?",0h
	szErrorText db "[Error] Error while opening file or file not selected!",0h
	szErrorTitle db "[Error]",0h
	szNotAValidEXEFile db "Selected file is not a valid EXE file!",0h
	szNotAValidPEFile db "Selected file is not a valid PE32 file!",0h
	szFileAlreadyPacked db "Selected file might be already packed with RLPack or some other packer! Do you want to continue?",0h
	szFoundCertificate db "RLPack has detected a security certificate apended to file.",13,10,"Since this certificate will not work after file packing it will be stripped!",0h
 ;
 ; LZMA
 ;
	szAPLIB db "aPLib 0.43",0h
	szSLZMA db "LZMA 4.30",0h

	szLZMA db "lzma.dll",0h
	szCompress db "Compress",0h
	szFreeCompressionMemory db "FreeCompressionMemory",0h
	
	szImporter db "Importer.dll",0h
	szImporterInit db "ImporterInit",0h
	szImporterCleanup db "ImporterCleanup",0h
	szImporterAddNewDll db "ImporterAddNewDll",0h
	szImporterAddNewAPI db "ImporterAddNewAPI",0h
	szImporterExportIAT db "ImporterExportIAT",0h
	szImporterEstimatedSize db "ImporterEstimatedSize",0h
	szImporterGetDLLIndexEx db "ImporterGetDLLIndexEx",0h
	szImporterGetAPINameEx db "ImporterGetAPINameEx",0h
	szImporterGetAddedDllCount db "ImporterGetAddedDllCount",0h
	szImporterGetAddedAPICount db "ImporterGetAddedAPICount",0h
	szImporterRelocateWriteLocation db "ImporterRelocateWriteLocation",0h
	szImporterMoveIAT db "ImporterMoveIAT",0h
 ;
 ; New PeHeader
 ;
	nPEHeader	db 04Dh,05Ah,090h,000h,003h,000h,000h,000h
			db 004h,000h,000h,000h,0FFh,0FFh,000h,000h
			db 0B8h,000h,000h,000h,000h,000h,000h,000h
			db 040h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,0B0h,000h,000h,000h
			db 00Eh,01Fh,0BAh,00Eh,000h,0B4h,009h,0CDh
			db 021h,0B8h,001h,04Ch,0CDh,021h,054h,068h
			db 069h,073h,020h,070h,072h,06Fh,067h,072h
			db 061h,06Dh,020h,063h,061h,06Eh,06Eh,06Fh
			db 074h,020h,062h,065h,020h,072h,075h,06Eh
			db 020h,069h,06Eh,020h,044h,04Fh,053h,020h
			db 06Dh,06Fh,064h,065h,02Eh,00Dh,00Dh,00Ah
			db 024h,000h,000h,000h,000h,000h,000h,000h
			db 05Dh,065h,0FDh,0C8h,019h,004h,093h,09Bh
			db 019h,004h,093h,09Bh,019h,004h,093h,09Bh
			db 097h,01Bh,080h,09Bh,011h,004h,093h,09Bh
			db 0E5h,024h,081h,09Bh,018h,004h,093h,09Bh
			db 052h,069h,063h,068h,019h,004h,093h,09Bh
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 050h,045h,000h,000h,04Ch,001h,002h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,0E0h,000h,000h,000h
			db 00Bh,001h,005h,00Ch,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,010h,000h,000h,000h,002h,000h,000h
			db 004h,000h,000h,000h,000h,000h,000h,000h
			db 004h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,002h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,010h,000h,000h,010h,000h,000h
			db 000h,000h,010h,000h,000h,010h,000h,000h
			db 000h,000h,000h,000h,010h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 02Eh,070h,061h,063h,06Bh,065h,064h,000h
			db 000h,060h,000h,000h,000h,010h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,020h,000h,000h,060h
			db 02Eh,052h,04Ch,050h,061h,063h,06Bh,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,020h,000h,000h,0E0h
			db 000h,000h,000h,000h,000h,000h,000h,000h
			db 000h,000h,000h,000h,000h,000h,000h,000h
	DLLAPISpacer db 01h
	Hundred dd 100
 .data?
	Compressor dd ?
	CmdLineNoMSGs dd ?
	CmdLineVersion dd ?
	CmdLineMinimize dd ?
	CmdLineTerminate dd ?
 ;
 ; LZMA
 ;
	hLZMA dd ?
	hCompress dd ?
	hFreeCompressionMemory dd ?
	
	hImporter dd ?
	cImporterInit dd ?
	cImporterCleanup dd ?
	cImporterAddNewDll dd ?
	cImporterAddNewAPI dd ?
	cImporterExportIAT dd ?
	cImporterEstimatedSize dd ?
	cImporterMoveIAT dd ?
	cImporterRelocateWriteLocation dd ?
 ;
 ; Misc
 ;
	HW dd ?
	BoxHwnd dd ?
	BoxHwnd2 dd ?
	packTypeLib dd ?
	szOpenFileName db MAX_PATH dup(?)
	szPackedFileName db MAX_PATH dup(?)
 ;
 ; Mapiranje fajla
 ;
	FileHWND dd ?
	FileSize dd ?
	FileMap dd ?
	FileMapVA dd ?
 ;
 ; Ostale promenljive
 ;
	hInstance dd ?
	buffer db 512 dup(?)
	rawbuffer db 512 dup(?)
	rPack dd ?
 ;
 ; Pe.Data
 ;
	SizeOfImage dd ?
	ImageBase dd ?
	PackedOEP dd ?
	NumberOfSections dd ?
	PEHeader dd ?
	TimeDateStamp dd ?
	Characteristics dd ?
	SubSytem dd ?
	DelayImportTable dd ?
	DelayImportTableSize dd ?
 ;
 ; Pack variables
 ;
	MAIN_ICON dd ?
	MAIN_ICON_SIZE dd ?
	MAIN_ICON_COUNT dd ?
	GROUP_ICON dd ?
	CurrentSectionNumber dd ?
        CurrentSectionOffset dd ?
        CompressSectionOffset dd ?
        VirtualSize dd ?
        VirtualOffset dd ?
        RawSize dd ?
        RawOffset dd ?
        SectionFlags dd ?
        Shareable dd ?
        
        OutMemBuffSize dd ?
        OutMemBuff dd ?
        WorkMemSize dd ?
        WorkMemBuff dd ?
        PackedSize dd ?
        hPackedFile dd ?
        hPackedFileBuff dd ?
        hPackedFilePos dd ?
        NumberOfBytesWritten dd ?
        
	FirstSectionOffset dd ?
	FirstSectionSize dd ?
	FirstSection dd ?
	SectionWriteOffset dd ?
	PackedSectionTable db 100 dup(?)
	STUB_DATA db 1024 dup(?)
	STUB_OEP dd ?
	STUB_OEP_OFFSET dd ?

	DLLNumber dd ?
	DLLPointer dd ?
	DLLNameBuff dd ?
	APINameBuff dd ?
	DLLNameBuff_Base dd ?
	APINameBuff_Base dd ?

	pFirst dd ?
	pRSRC dd ?
	RSRCSize dd ?
	pRSRCBuff dd ?
	pRSRCBuffPos dd ?
	pRSRCBuffSize dd ?
	RSRCSectionNumber dd ?
	Level1_CNT dd ?
	Level2_CNT dd ?
	Level3_CNT dd ?
	pSize dd ?
	pType dd ?
	pName dd ?
	pRelOffsetToData dd ?
	pDataRVA dd ?
	pOffset dd ?
	oStripReloc dd ?
	oStripTLS dd ?
	OriginalSize dd ?
	Ratio dd ?
	LastRatio dd ?
	oStripRSRC dd ?
	ThreadRunning dd ?
	oOverlay dd ?
	oExportTable dd ?
	oStaticDLLImport dd ?
	orgExportAddr dd ?
	orgExportSize dd ?
	ExportTableBuffSize dd ?
	ExportTableBuff dd ?
	OverlayExists dd ?
	hSaveFile dd ?
	eStart dd ?
	eSize dd ?
	RelocationRVA dd ?
	IsDll dd ?
	AddedDLLFile dd ?
	ReadDataBuffer db 1000h dup(?)
	tmpRelocations db 2000h dup(?)
 .code

start:
	INVOKE GetModuleHandle,addr szImporter
	.if EAX == NULL
		INVOKE LoadLibrary,addr szImporter
	.endif
	MOV DWORD PTR[hImporter],EAX
	.if DWORD PTR[hImporter] != 0 && DWORD PTR[cImporterInit] == NULL
		INVOKE GetProcAddress,DWORD PTR[hImporter],addr szImporterInit
		MOV DWORD PTR[cImporterInit],EAX
		INVOKE GetProcAddress,DWORD PTR[hImporter],addr szImporterAddNewDll
		MOV DWORD PTR[cImporterAddNewDll],EAX
		INVOKE GetProcAddress,DWORD PTR[hImporter],addr szImporterAddNewAPI
		MOV DWORD PTR[cImporterAddNewAPI],EAX
		INVOKE GetProcAddress,DWORD PTR[hImporter],addr szImporterExportIAT
		MOV DWORD PTR[cImporterExportIAT],EAX
		INVOKE GetProcAddress,DWORD PTR[hImporter],addr szImporterEstimatedSize
		MOV DWORD PTR[cImporterEstimatedSize],EAX
		INVOKE GetProcAddress,DWORD PTR[hImporter],addr szImporterMoveIAT
		MOV DWORD PTR[cImporterMoveIAT],EAX
		INVOKE GetProcAddress,DWORD PTR[hImporter],addr szImporterRelocateWriteLocation
		MOV DWORD PTR[cImporterRelocateWriteLocation],EAX
	.endif

        invoke GetModuleHandle, NULL
        mov hInstance, eax
        ; -------------------------------------------
        ; Call the dialog box stored in resource file
        ; -------------------------------------------
        invoke DialogBoxParam,hInstance,ADDR dlgname,0,ADDR WndProc,0
        invoke ExitProcess,eax
	RET
;------------------------------------------------------------------
GetParametars:
	PUSHAD
	MOV CmdLineTerminate,0
	MOV CmdLineNoMSGs,0
	MOV CmdLineMinimize,0
	INVOKE RtlZeroMemory,addr buffer,512
	INVOKE GetCommandLine
	INVOKE lstrcpy,addr buffer,EAX
	MOV ESI,offset buffer
	MOV EDI,EAX
	INVOKE lstrlen,ESI
	ADD ESI,EAX
	.if BYTE PTR[ESI-1] == 22h
		MOV BYTE PTR[ESI-1],0
	.endif
	.while ESI > EDI && BYTE PTR[ESI] != "-"
		DEC ESI
	.endw
	.if BYTE PTR[ESI] == "-"
		INC ESI
		INVOKE GetDlgItem,HW,600
		INVOKE CheckDlgButton,HW,600,0
		INVOKE GetDlgItem,HW,601
		INVOKE CheckDlgButton,HW,601,0
		INVOKE GetDlgItem,HW,602
		INVOKE CheckDlgButton,HW,602,0
		INVOKE GetDlgItem,HW,610
		INVOKE CheckDlgButton,HW,610,0
		INVOKE GetDlgItem,HW,611
		INVOKE CheckDlgButton,HW,611,0
		INVOKE GetDlgItem,HW,619
		INVOKE CheckDlgButton,HW,619,0
		INVOKE GetDlgItem,HW,623
		INVOKE CheckDlgButton,HW,623,0
		.while BYTE PTR[ESI] != " "
			.if BYTE PTR[ESI] == "b" || BYTE PTR[ESI] == "B"
				INVOKE GetDlgItem,HW,600
				INVOKE CheckDlgButton,HW,600,1
			.elseif BYTE PTR[ESI] == "t" || BYTE PTR[ESI] == "T"
				INVOKE GetDlgItem,HW,602
				INVOKE CheckDlgButton,HW,602,1
			.elseif BYTE PTR[ESI] == "r" || BYTE PTR[ESI] == "R"
				INVOKE GetDlgItem,HW,601
				INVOKE CheckDlgButton,HW,601,1
			.elseif BYTE PTR[ESI] == "e" || BYTE PTR[ESI] == "E"
				INVOKE GetDlgItem,HW,619
				INVOKE CheckDlgButton,HW,619,1
			.elseif BYTE PTR[ESI] == "s" || BYTE PTR[ESI] == "S"
				INVOKE GetDlgItem,HW,610
				INVOKE CheckDlgButton,HW,610,1
			.elseif BYTE PTR[ESI] == "w" || BYTE PTR[ESI] == "W"
				INVOKE GetDlgItem,HW,623
				INVOKE CheckDlgButton,HW,623,1
			.elseif BYTE PTR[ESI] == "o" || BYTE PTR[ESI] == "O"
				INVOKE GetDlgItem,HW,611
				INVOKE CheckDlgButton,HW,611,1
			.elseif BYTE PTR[ESI] == "a" || BYTE PTR[ESI] == "A"
				INVOKE SendMessage,BoxHwnd2,CB_SETCURSEL,NULL,NULL
			.elseif BYTE PTR[ESI] == "l" || BYTE PTR[ESI] == "L"
				INVOKE SendMessage,BoxHwnd2,CB_SETCURSEL,1,NULL
			.elseif BYTE PTR[ESI] == "c" || BYTE PTR[ESI] == "C"
				INC CmdLineTerminate
			.elseif BYTE PTR[ESI] == "q" || BYTE PTR[ESI] == "Q"
				MOV CmdLineNoMSGs,1
			.elseif BYTE PTR[ESI] == "m" || BYTE PTR[ESI] == "M"
				MOV CmdLineMinimize,1
			.endif
			INC ESI
		.endw
		INC ESI
		INVOKE lstrcpy,addr szOpenFileName,ESI
		INVOKE lstrcpy,addr szPackedFileName,ESI
		INVOKE lstrcat,addr szPackedFileName,addr szPackedExe
		MOV FileMapVA,-1
		INVOKE MapFile,addr szOpenFileName
		.if FileMapVA != -1
			INVOKE SetDlgItemText,HW,102,addr szOpenFileName
			MOV CmdLineVersion,1
			INVOKE UnmapFile
		.else
			INVOKE UnmapFile
			MOV CmdLineVersion,NULL
			MOV CmdLineTerminate,NULL
			INVOKE GetDlgItem,HW,600
			INVOKE CheckDlgButton,HW,600,1
			INVOKE GetDlgItem,HW,601
			INVOKE CheckDlgButton,HW,601,1
			INVOKE GetDlgItem,HW,610
			INVOKE CheckDlgButton,HW,610,1
			INVOKE GetDlgItem,HW,611
			INVOKE CheckDlgButton,HW,611,1
		.endif
	.else
		MOV CmdLineVersion,NULL
		MOV CmdLineTerminate,NULL
	.endif

	POPAD
	RET
;------------------------------------------------------------------
WndProc3 proc hWin  :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

	LOCAL LocRetn :DWORD
	LOCAL lBoxHwnd :DWORD

	PUSHAD
	MOV LocRetn,0
      .if uMsg == WM_INITDIALOG
	        MOV LocRetn,1
	        invoke GetModuleHandle, NULL
	        mov hInstance, eax
		invoke SendMessage,hWin,WM_SETTEXT,0,ADDR dlgTitle3
		invoke LoadIcon,hInstance,500    ; icon ID
		PUSH EAX
		PUSH 0
		PUSH 80h
		PUSH hWin
		CALL SendMessage
		INVOKE LoadBitmap,hInstance,510
		MOV EDI,EAX
		INVOKE GetDlgItem,hWin,7000
		INVOKE SendMessage,EAX,STM_SETIMAGE,IMAGE_BITMAP,EDI
		
		MOV ESI,7001
		.while ESI <= 7025
			INVOKE CheckDlgButton,hWin,ESI,1
			INC ESI
		.endw

		INVOKE RtlZeroMemory,addr rawbuffer,512
	        INVOKE GetDlgItem,HW,1002
		MOV ESI,EAX
		INVOKE GetWindowTextLength,ESI
		.if EAX > 0
			INC EAX
			INVOKE GetWindowText,ESI,addr buffer,EAX
			INVOKE lstrcat,addr buffer,addr comma
	
			MOV EAX,offset buffer
			MOV EBX,offset rawbuffer
			MOV ECX,EAX
			.while BYTE PTR[EAX] != 0
				.if BYTE PTR[EAX] == ','
					MOV BYTE PTR[EAX],0
					MOV EDI,EAX
					PUSH ECX
					CALL _convert_text_2_number
					MOV DWORD PTR[EBX],EAX
					ADD EBX,4
					MOV EAX,EDI
					LEA ECX,DWORD PTR[EAX+1]
				.endif
				INC EAX
			.endw
			MOV EBX,offset rawbuffer
			.while DWORD PTR[EBX] != 0
				.if DWORD PTR[EBX] >= 1 && DWORD PTR[EBX] <= 24
					MOV ESI,7000
					ADD ESI,DWORD PTR[EBX]
					PUSHAD
					INVOKE CheckDlgButton,hWin,ESI,0
					POPAD
				.endif
				ADD EBX,4
			.endw
			.if packTypeLib == NULL
				INVOKE CheckDlgButton,hWin,7025,0
			.endif
		.else
			INVOKE CheckDlgButton,hWin,7016,0
			INVOKE CheckDlgButton,hWin,7024,0
			INVOKE CheckDlgButton,hWin,7025,0
		.endif

      .elseif uMsg == WM_CLOSE
		INVOKE EndDialog,hWin,0

      .elseif uMsg == WM_COMMAND
        .if wParam == 8000
		INVOKE RtlZeroMemory,addr ReadDataBuffer,1000h
        	MOV packTypeLib,0
		MOV ESI,7001
		.while ESI <= 7025
			INVOKE IsDlgButtonChecked,hWin,ESI
			.if EAX == FALSE
				MOV EDI,ESI
				SUB EDI,7000
				.if EDI <= 24 && EDI != 13 && EDI != 15 && EDI != 18
					PUSH EDI
					PUSH offset szRSRCPackFormat
					PUSH offset buffer
					CALL wsprintf
					ADD ESP,0Ch
					INVOKE lstrcat,addr ReadDataBuffer,addr buffer
				.endif
			.else
				MOV EDI,ESI
				SUB EDI,7000
				.if EDI == 25
					MOV packTypeLib,1
				.endif
			.endif
			INC ESI
		.endw
		INVOKE lstrlen,addr ReadDataBuffer
		ADD EAX,offset ReadDataBuffer
		MOV BYTE PTR[EAX-1],0
		INVOKE GetDlgItem,HW,1002
		INVOKE SetWindowText,EAX,addr ReadDataBuffer
	        INVOKE EndDialog,hWin,0
        .elseif wParam == 8001
	        INVOKE EndDialog,hWin,0
        .endif
      .endif

	POPAD
	MOV EAX,LocRetn
	RET
WndProc3 endp
;------------------------------------------------------------------
WndProc2 proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

	LOCAL LocRetn :DWORD

	PUSHAD
	MOV LocRetn,0
      .if uMsg == WM_INITDIALOG
	        MOV LocRetn,1
	        invoke GetModuleHandle, NULL
	        mov hInstance, eax
		invoke SendMessage,hWin,WM_SETTEXT,0,ADDR dlgTitle2
		invoke LoadIcon,hInstance,500    ; icon ID
		MOV EDI,EAX
		PUSH EAX
		PUSH 0
		PUSH 80h
		PUSH hWin
		CALL SendMessage
		INVOKE GetDlgItem,hWin,3003
		INVOKE SendMessage,EAX,STM_SETIMAGE,IMAGE_ICON,EDI
		INVOKE LoadBitmap,hInstance,510
		MOV EDI,EAX
		INVOKE GetDlgItem,hWin,3001
		INVOKE SendMessage,EAX,STM_SETIMAGE,IMAGE_BITMAP,EDI

      .elseif uMsg == WM_CLOSE
		invoke EndDialog,hWin,0

      .elseif uMsg == WM_COMMAND
        .if wParam == 3005
	        invoke EndDialog,hWin,0
	.elseif wParam == 3006
		INVOKE ShellExecute,NULL,addr szOpen,addr szMyWebSite,NULL,NULL,TRUE
	.elseif wParam == 3007
		INVOKE ShellExecute,NULL,addr szOpen,addr szMyUpdate,NULL,NULL,TRUE
        .endif
      .endif

	POPAD
	MOV EAX,LocRetn
	RET
WndProc2 endp
;------------------------------------------------------------------
WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

      .if uMsg == WM_INITDIALOG
		MOV EAX,[hWin]
		MOV [HW],EAX
		invoke SendMessage,hWin,WM_SETTEXT,0,ADDR dlgTitle
		invoke LoadIcon,hInstance,500    ; icon ID

		PUSH EAX
		PUSH 0
		PUSH 80h
		PUSH hWin
		CALL SendMessage

		PUSH 600
		PUSH DWORD PTR DS:[hWin]
		CALL GetDlgItem
		PUSH 1
		PUSH 600
		PUSH [hWin]
		CALL CheckDlgButton
		
		PUSH 601
		PUSH DWORD PTR DS:[hWin]
		CALL GetDlgItem
		PUSH 1
		PUSH 601
		PUSH [hWin]
		CALL CheckDlgButton

		PUSH 610
		PUSH DWORD PTR DS:[hWin]
		CALL GetDlgItem
		PUSH 1
		PUSH 610
		PUSH [hWin]
		CALL CheckDlgButton

		PUSH 611
		PUSH DWORD PTR DS:[hWin]
		CALL GetDlgItem
		PUSH 1
		PUSH 611
		PUSH [hWin]
		CALL CheckDlgButton

		PUSH 6Fh
		PUSH [hWin]
		CALL GetDlgItem
		MOV [BoxHwnd],EAX
		PUSH 0
		PUSH 0
		PUSH 184h
		PUSH [BoxHwnd]
		CALL SendMessage

		PUSHAD
		INVOKE LoadLibrary,addr szLZMA
		MOV hLZMA,EAX
		INVOKE GetProcAddress,hLZMA,addr szCompress
		MOV hCompress,EAX
		INVOKE GetProcAddress,hLZMA,addr szFreeCompressionMemory
		MOV hFreeCompressionMemory,EAX
		INVOKE GetDlgItem,hWin,1001
		MOV BoxHwnd2,EAX
		INVOKE SendMessage,BoxHwnd2,CB_ADDSTRING,NULL,addr szAPLIB
		INVOKE SendMessage,BoxHwnd2,CB_ADDSTRING,NULL,addr szSLZMA
		INVOKE SendMessage,BoxHwnd2,CB_SETCURSEL,NULL,NULL
		POPAD
		
		CALL GetParametars

		PUSHAD
		PUSH offset szInfo_Version
		CALL _show_log_message_2
		PUSH offset szInfo_UserName
		CALL _show_log_message_2
		PUSH offset szInfo_License1
		CALL _show_log_message_2
		POPAD

      .elseif uMsg == WM_SHOWWINDOW
		.if BYTE PTR[szOpenFileName] != 0 && CmdLineVersion == 1
			.if CmdLineMinimize == 1
				INVOKE CloseWindow,HW
			.endif
			.if ThreadRunning == 0
				PUSH offset ThreadRunning
				PUSH NULL
				PUSH NULL
				PUSH offset pack
				PUSH NULL
				PUSH NULL
				CALL CreateThread
			.endif
		.endif

      .elseif uMsg == WM_DROPFILES
		PUSHAD
		invoke DragQueryFile,wParam,0,ADDR buffer,256
		INVOKE lstrcpy,addr szOpenFileName,addr buffer
		INVOKE lstrcpy,addr szPackedFileName,addr buffer
		INVOKE lstrcat,addr szPackedFileName,addr szPackedExe
		PUSH offset szOpenFileName
		PUSH 102
		PUSH DWORD PTR DS:[hWin]
		CALL SetDlgItemText
		POPAD

      .elseif uMsg == WM_CLOSE
		invoke EndDialog,hWin,0

      .elseif uMsg == WM_COMMAND

        .if wParam == 107
		.if BYTE PTR[szOpenFileName] != 0
			.if ThreadRunning == 0
				PUSH offset ThreadRunning
				PUSH NULL
				PUSH NULL
				PUSH offset pack
				PUSH NULL
				PUSH NULL
				CALL CreateThread
			.endif
		.else
			INVOKE MessageBox,NULL,addr szErrorText,addr szErrorTitle,30h
		.endif
        .endif
        .if wParam == 106
		INVOKE ShellExecute,NULL,addr szOpen,addr szCHM,NULL,NULL,TRUE
        .endif
        .if wParam == 108
		INVOKE GetExeFile

		.if BYTE PTR[szOpenFileName] != 0
			PUSH offset szOpenFileName
			PUSH 102
			PUSH DWORD PTR DS:[hWin]
			CALL SetDlgItemText
		.endif
        .endif
        .if wParam == 109
		INVOKE FindWindow,NULL,addr dlgTitle2
		.if EAX == NULL
		        INVOKE DialogBoxParam,hInstance,ADDR dlgname2,0,ADDR WndProc2,0
		.endif
        .endif
        .if wParam == 110
		INVOKE ShellExecute,NULL,addr szOpen,addr WebSite,NULL,NULL,TRUE
        .endif
        .if wParam == 112
		INVOKE FindWindow,NULL,addr dlgTitle3
		.if EAX == NULL
		        INVOKE DialogBoxParam,hInstance,ADDR dlgname3,0,ADDR WndProc3,0
		.endif
        .endif

      .endif

    xor eax, eax
    ret

WndProc endp
;------------------------------------------------------------------
; Pocetak packera
;
;
pack:
	PUSHAD
;
; Erase all variables!
;
	MOV CmdLineVersion,NULL
	INVOKE RtlZeroMemory,addr FileHWND,4000
	MOV ThreadRunning,1

	INVOKE SendMessage,BoxHwnd2,CB_GETCURSEL,NULL,NULL
	INC EAX
	MOV Compressor,EAX

	PUSH 6Fh
	PUSH DWORD PTR DS:[HW]
	CALL GetDlgItem
	MOV [BoxHwnd],EAX
	PUSH 0
	PUSH 0
	PUSH 184h
	PUSH [BoxHwnd]
	CALL SendMessage

	PUSH offset szPackStart
	CALL _show_log_message

	INVOKE GetDlgItem,HW,1002
	MOV ESI,EAX
	INVOKE GetWindowTextLength,ESI
	INC EAX
	INVOKE GetWindowText,ESI,addr buffer,EAX
	INVOKE lstrcat,addr buffer,addr comma

	MOV EAX,offset buffer
	MOV EBX,offset rawbuffer
	MOV ECX,EAX
	.while BYTE PTR[EAX] != 0
		.if BYTE PTR[EAX] == ','
			MOV BYTE PTR[EAX],0
			MOV EDX,EAX
			PUSH ECX
			CALL _convert_text_2_number
			MOV DWORD PTR[EBX],EAX
			ADD EBX,4
			MOV EAX,EDX
			LEA ECX,DWORD PTR[EAX+1]
		.endif
		INC EAX
	.endw

	PUSH 600
	PUSH [HW]
	CALL IsDlgButtonChecked
	.if EAX == TRUE
		INVOKE CopyFile,addr szOpenFileName,addr szPackedFileName,FALSE
	.endif

	PUSH 601
	PUSH [HW]
	CALL IsDlgButtonChecked
	.if EAX == TRUE
		MOV oStripReloc,1
	.endif

	PUSH 602
	PUSH [HW]
	CALL IsDlgButtonChecked
	.if EAX == TRUE
		.if CmdLineNoMSGs == NULL
			MOV oStripTLS,1
			INVOKE MessageBox,NULL,addr szStripTLS,addr szWarningTitle,MB_ICONWARNING+MB_YESNO
			.if EAX == 7
				MOV oStripTLS,0
			.endif
		.else
			MOV oStripTLS,0
		.endif
	.endif

	PUSH 610
	PUSH [HW]
	CALL IsDlgButtonChecked
	.if EAX == TRUE
		MOV oStripRSRC,1
	.endif

	PUSH 611
	PUSH [HW]
	CALL IsDlgButtonChecked
	.if EAX == TRUE
		MOV oOverlay,1
	.endif

	PUSH 619
	PUSH [HW]
	CALL IsDlgButtonChecked
	.if EAX == TRUE
		MOV oExportTable,1
	.endif
	
	PUSH 623
	PUSH [HW]
	CALL IsDlgButtonChecked
	.if EAX == TRUE
		MOV oStaticDLLImport,1
	.endif

;------------------------------------------------------------------
; Check the PE32/exe file
;

	MOV FileMapVA,-1
	INVOKE MapFile,addr szOpenFileName
	.if FileMapVA == -1
		MOV EAX,offset ERROR_EXIT
		JMP EAX
	.endif
	MOV EBX,FileMapVA
	.if WORD PTR[EBX] != 'ZM'
		.if CmdLineNoMSGs == NULL
			INVOKE MessageBox,NULL,addr szNotAValidEXEFile,addr szErrorTitle,MB_ICONERROR+MB_OK
		.endif
		PUSH offset szUnpackable
		CALL _show_log_message
		INVOKE UnmapFile
		MOV EAX,offset ERROR_EXIT
		JMP EAX
	.endif
	ADD EBX,3Ch
	ADD BX,WORD PTR[EBX]		;WinME/98/95 compatibility!
	SUB BX,3Ch			;
	.if WORD PTR[EBX] != 'EP'
		.if CmdLineNoMSGs == NULL
			INVOKE MessageBox,NULL,addr szNotAValidPEFile,addr szErrorTitle,MB_ICONERROR+MB_OK
		.endif
		PUSH offset szUnpackable
		CALL _show_log_message
		INVOKE UnmapFile
		MOV EAX,offset ERROR_EXIT
		JMP EAX
	.endif
	MOVZX ECX,WORD PTR[EBX+6h]
	MOV EAX,DWORD PTR[EBX+28h]
	INVOKE GetSectionNumber,FileMapVA,EAX
	.if ECX < EAX
		.if CmdLineNoMSGs == NULL
			INVOKE MessageBox,NULL,addr szFileAlreadyPacked,addr szErrorTitle,MB_ICONERROR+MB_YESNO
			.if EAX == 7
				INVOKE UnmapFile
				PUSH offset szUnpackable
				CALL _show_log_message
				INVOKE UnmapFile
				MOV EAX,offset ERROR_EXIT
				JMP EAX
			.endif
		.endif
	.endif
	INVOKE UnmapFile

;------------------------------------------------------------------
; Copy Overlay
;

	.if oOverlay == 1
		INVOKE ExtractOverlay,addr szOpenFileName,addr szTMP
		.if EAX > 0
			MOV OverlayExists,EAX
		.endif
	.endif

;------------------------------------------------------------------
; Begin packing
;

	INVOKE MapFile,addr szOpenFileName

	MOV EAX,FileSize
	MOV OriginalSize,EAX
	PUSH EAX
	PUSH offset OSize_format
	PUSH offset buffer
	CALL wsprintf
	ADD ESP,0Ch
	PUSH 603
	PUSH DWORD PTR DS:[HW]
	CALL GetDlgItem
	PUSH offset buffer
	PUSH EAX
	CALL SetWindowText

	MOV EAX,FileSize
	ADD EAX,500000h
	INVOKE VirtualAlloc,NULL,EAX,MEM_COMMIT,PAGE_EXECUTE_READWRITE
	MOV hPackedFileBuff,EAX
	MOV hPackedFilePos,EAX

	INVOKE RtlMoveMemory,hPackedFilePos,addr nPEHeader,200h
	ADD hPackedFilePos,200h

	MOV EBX,FileMapVA
	ADD EBX,3Ch
	ADD BX,WORD PTR[EBX]		;WinME/98/95 compatibility!
	SUB BX,3Ch			;
	MOV PEHeader,EBX
	MOV EAX,DWORD PTR[EBX+28h]
	MOV PackedOEP,EAX
	MOV EAX,DWORD PTR[EBX+34h]
	MOV ImageBase,EAX
	ADD PackedOEP,EAX
	MOVZX EAX,WORD PTR[EBX+6h]
	MOV NumberOfSections,EAX
	MOV CurrentSectionNumber,EAX

;------------------------------------------------------------------
; Load needed PE.data
;
;
	MOV EAX,DWORD PTR[EBX+8h]
	MOV TimeDateStamp,EAX
	MOV EAX,DWORD PTR[EBX+16h]
	MOV Characteristics,EAX
	MOVZX EAX,WORD PTR[EBX+5Ch]
	MOV SubSytem,EAX
	MOV EAX,DWORD PTR[EBX+0A0h]
	MOV IsDll,0
	MOV RelocationRVA,0
	TEST WORD PTR[Characteristics],2000h
	JE _not_a_dll
		MOV RelocationRVA,EAX
		MOV IsDll,1
 _not_a_dll:
 	.if IsDll == 1
		MOV EAX,hPackedFileBuff
		LEA EAX,DWORD PTR[EAX+1D0h]
		MOV DWORD PTR[EAX],"."
		MOV DWORD PTR[EAX+4],0
		INC EAX
		MOV DWORD PTR[EAX],"crsr"
 	.endif
	MOV EAX,DWORD PTR[EBX+098h]
	.if EAX != 0 && oOverlay == 1
		PUSHAD
		.if CmdLineNoMSGs == NULL
			INVOKE MessageBox,NULL,addr szFoundCertificate,addr szWarningTitle,MB_ICONWARNING+MB_OK
		.endif
		INVOKE DeleteFile,addr szTMP
		MOV oOverlay,0
		POPAD
	.endif
	MOV EAX,DWORD PTR[EBX+0E0h]
	MOV DelayImportTable,EAX
	MOV EAX,DWORD PTR[EBX+0E4h]
	MOV DelayImportTableSize,EAX

;------------------------------------------------------------------
; SizeOfImage calculation
;
;
	MOV EAX,DWORD PTR[EBX+50h]
	MOV EDI,EAX
	CDQ
	MOV ECX,1000h
	DIV ECX
	IMUL EAX,1000h
	.if EDI > EAX
		ADD EAX,1000h
	.endif
	MOV SizeOfImage,EAX

;------------------------------------------------------------------
; Load IAT
;
;

	PUSH offset szLoadIat
	CALL _show_log_message

	INVOKE VirtualAlloc,NULL,500000h,MEM_COMMIT,PAGE_EXECUTE_READWRITE
	MOV DLLNameBuff,EAX
	MOV DLLNameBuff_Base,EAX
	INVOKE VirtualAlloc,NULL,500000h,MEM_COMMIT,PAGE_EXECUTE_READWRITE
	MOV APINameBuff,EAX
	MOV APINameBuff_Base,EAX
	INVOKE RtlZeroMemory,addr ReadDataBuffer,1000h

	MOV EAX,PEHeader
	MOV EAX,DWORD PTR[EAX+80h]
	.if EAX != 0
		ADD EAX,ImageBase
		INVOKE ConvertVA2FO,FileMapVA,EAX
		ADD EAX,FileMapVA
		MOV DLLPointer,EAX
		
		.if oStaticDLLImport == 1
			PUSH ImageBase
			PUSH 20*1024
			CALL DWORD PTR[cImporterInit]
			CALL DWORD PTR[cImporterMoveIAT]
			XOR ESI,ESI
			PUSH offset ReadDataBuffer
			PUSH offset __kernel32
			CALL IsDLLNameAdded
			PUSH NULL
			PUSH offset __kernel32
			CALL DWORD PTR[cImporterAddNewDll]
			
			PUSH ESI
			PUSH offset __loadlib
			CALL DWORD PTR[cImporterAddNewAPI]
			ADD ESI,4
			PUSH ESI
			PUSH offset __gpa
			CALL DWORD PTR[cImporterAddNewAPI]
			ADD ESI,4
			PUSH ESI
			PUSH offset __va
			CALL DWORD PTR[cImporterAddNewAPI]
			ADD ESI,4
			PUSH ESI
			PUSH offset __vf
			CALL DWORD PTR[cImporterAddNewAPI]
			ADD ESI,4
			PUSH ESI
			PUSH offset __vp
			CALL DWORD PTR[cImporterAddNewAPI]
			ADD ESI,12
			SUB ESI,8
		.endif
		.while DLLPointer != 0
			INC DLLNumber

			MOV EBX,DLLPointer
			ADD EBX,12
			MOV EBX,DWORD PTR[EBX]
			ADD EBX,ImageBase

			INVOKE ConvertVA2FO,FileMapVA,EBX
			ADD EAX,FileMapVA
			MOV EDI,EAX

			MOV AddedDLLFile,0
			.if oStaticDLLImport == 1
				PUSH offset ReadDataBuffer
				PUSH EDI
				CALL IsDLLNameAdded
				.if EAX == TRUE
					INC AddedDLLFile
					PUSH NULL
					PUSH EDI
					CALL DWORD PTR[cImporterAddNewDll]
				.endif
			.endif

			INVOKE lstrcpy,DLLNameBuff,EDI
			INVOKE lstrlen,DLLNameBuff
			INC EAX
			ADD DLLNameBuff,EAX
			INVOKE RtlZeroMemory,EDI,EAX

			MOV EBX,DLLPointer
			MOV ECX,DWORD PTR[EBX]
			MOV EDX,ECX
			ADD EDX,ImageBase

			ADD EBX,16
			MOV ECX,DWORD PTR[EBX]
			.if EDX == ImageBase
				ADD EDX,ECX
			.endif

;			ADD ECX,ImageBase

			MOV EAX,APINameBuff
			MOV DWORD PTR[EAX],ECX
			ADD APINameBuff,4

			ADD ESI,8
			PUSH ESI
			INVOKE ConvertVA2FO,FileMapVA,EDX
			ADD EAX,FileMapVA
			.while DWORD PTR[EAX] != 0
				MOV EBX,DWORD PTR[EAX]
				.if EBX < 80000000h
					ADD EBX,2
					ADD EBX,ImageBase
					PUSHAD
					INVOKE ConvertVA2FO,FileMapVA,EBX
					ADD EAX,FileMapVA
					MOV EDI,EAX
					XOR EBX,EBX
					PUSHAD
					.while BYTE PTR[EDI] != 0
						MOV DL,BYTE PTR[EDI]
						ROL EBX,7
						XOR BL,DL
						INC EDI
					.endw
					MOV ECX,APINameBuff
					MOV DWORD PTR[ECX],EBX
					ADD APINameBuff,4
					POPAD

					.if oStaticDLLImport == 1
						.if ESI != -1 && AddedDLLFile == 1
							PUSH ESI
							PUSH EDI
							CALL DWORD PTR[cImporterAddNewAPI]
						.endif
					.endif

					INVOKE lstrlen,EDI
					ADD EAX,2
					SUB EDI,2
					INVOKE RtlZeroMemory,EDI,EAX
					POPAD
;					INC APINumber
				.else
					PUSHAD
					.if oStaticDLLImport == 1
						.if ESI != -1 && AddedDLLFile == 1
							MOV EDI,EBX
							XOR EDI,80000000h
							PUSH ESI
							PUSH EDI
							CALL DWORD PTR[cImporterAddNewAPI]
						.endif
					.endif
					MOV ECX,APINameBuff
					MOV DWORD PTR[ECX],EBX
					ADD APINameBuff,4
					POPAD
;					INC APINumber
				.endif
				XOR ESI,ESI
				DEC ESI
				MOV DWORD PTR[EAX],0
				ADD EAX,4
			.endw
			POP ESI
			ADD APINameBuff,4
			ADD DLLPointer,14h
			MOV EAX,DLLPointer
			ADD EAX,12
			.if DWORD PTR[EAX] == 0
				MOV DLLPointer,0
			.endif
		.endw
	.endif
	INVOKE RtlZeroMemory,addr ReadDataBuffer,1000h	

;------------------------------------------------------------------
; Strip IAT
;
;

	MOV EAX,FileMapVA
	ADD EAX,3Ch
	ADD AX,WORD PTR[EAX]		;WinME/98/95 compatibility!
	SUB AX,3Ch			;
	MOV EBX,DWORD PTR[EAX+0D8h]
	MOV ECX,DWORD PTR[EAX+0DCh]
	.if EBX > 0 && ECX > 0
		ADD EBX,ImageBase
		INVOKE ConvertVA2FO,FileMapVA,EBX
		ADD EAX,FileMapVA
		INVOKE RtlZeroMemory,EAX,ECX
	.endif

;------------------------------------------------------------------
; Strip export table
;
;

	.if oExportTable == 1 && IsDll == 0
		MOV EAX,FileMapVA
		ADD EAX,3Ch
		ADD AX,WORD PTR[EAX]		;WinME/98/95 compatibility!
		SUB AX,3Ch			;
		MOV EBX,DWORD PTR[EAX+78h]
		MOV ECX,DWORD PTR[EAX+7Ch]
		.if EBX > 0 && ECX > 0
			ADD EBX,ImageBase
			INVOKE ConvertVA2FO,FileMapVA,EBX
			ADD EAX,FileMapVA
			INVOKE RtlZeroMemory,EAX,ECX
		.endif
	.endif

;------------------------------------------------------------------

	CALL FindMainIcon

;------------------------------------------------------------------
; Load Resources
;
;

	PUSH offset szPackingResources
	CALL _show_log_message

	PUSH MAIN_ICON_COUNT

	MOV GROUP_ICON,NULL
	MOV pFirst,1
	MOV EBX,FileMapVA
	ADD EBX,3Ch
	ADD BX,WORD PTR[EBX]		;WinME/98/95 compatibility!
	SUB BX,3Ch			;

	MOV PEHeader,EBX
	MOV EAX,DWORD PTR[EBX+88h]
	.if EAX != 0
		ADD EAX,ImageBase
		MOV EBX,EAX
		INVOKE GetSectionNumber,FileMapVA,EAX
		MOV RSRCSectionNumber,EAX
		INVOKE ConvertVA2FO,FileMapVA,EBX
		ADD EAX,FileMapVA
		MOV pRSRC,EAX

		MOVZX EBX,WORD PTR[EAX+12]
		ADD BX,WORD PTR[EAX+14]
		MOV Level1_CNT,EBX
		ADD EAX,16
		.while Level1_CNT > 0
			MOV EBX,DWORD PTR[EAX]
			MOV pType,EBX
			MOV EBX,DWORD PTR[EAX+4]
			XOR EBX,80000000h
			ADD EBX,pRSRC
			MOVZX ECX,WORD PTR[EBX+12]
			ADD CX,WORD PTR[EBX+14]
			MOV Level2_CNT,ECX
			ADD EBX,16
                        .while Level2_CNT > 0
				MOV ECX,DWORD PTR[EBX]
				MOV pName,ECX
				.if pFirst == 1
					PUSHAD
					MOV ECX,DWORD PTR[EBX]
					.if ECX > 80000000h || pType > 80000000h
						.if ECX < 80000000h
							MOV ECX,pType
						.endif
						XOR ECX,80000000h
						ADD ECX,pRSRC
						.if BYTE PTR[ECX] != NULL
							.while BYTE PTR[ECX] != NULL
								ADD ECX,2
							.endw
							MOV pFirst,2
							ADD ECX,2
							SUB ECX,pRSRC
							MOV RSRCSize,ECX
						.endif
					.endif
					POPAD
				.endif
				MOV ECX,DWORD PTR[EBX+4]
				XOR ECX,80000000h
				ADD ECX,pRSRC
				MOVZX EDX,WORD PTR[ECX+12]
				ADD DX,WORD PTR[ECX+14]
				MOV Level3_CNT,EDX
				ADD ECX,16
				.while Level3_CNT > 0
					MOV EDX,DWORD PTR[ECX+4]
					ADD EDX,pRSRC
					MOV EDI,DWORD PTR[EDX]
					MOV pDataRVA,EDI
					MOV EDI,DWORD PTR[EDX+4]
					MOV pSize,EDI

					.if pFirst == 1
						MOV pFirst,0
						PUSHAD
						MOV EAX,pDataRVA
						ADD EAX,ImageBase
						INVOKE ConvertVA2FO,FileMapVA,EAX
						ADD EAX,FileMapVA
						SUB EAX,pRSRC
						MOV EBX,EAX
						ROL EBX,8
						.if BL < 7Fh
							MOV RSRCSize,EAX
							PUSHAD
							ADD EAX,500000h
							MOV pRSRCBuffSize,EAX
							INVOKE VirtualAlloc,NULL,EAX,MEM_COMMIT,PAGE_EXECUTE_READWRITE
							MOV pRSRCBuff,EAX
							MOV pRSRCBuffPos,EAX
							INVOKE RtlMoveMemory,pRSRCBuff,pRSRC,RSRCSize
							MOV EAX,RSRCSize
							ADD pRSRCBuffPos,EAX
							POPAD
						.else
							INC pFirst
						.endif
						POPAD
					.elseif pFirst == 2
						MOV pFirst,0
						PUSHAD
						MOV EAX,RSRCSize
						ADD EAX,500000h
						MOV pRSRCBuffSize,EAX
						INVOKE VirtualAlloc,NULL,EAX,MEM_COMMIT,PAGE_EXECUTE_READWRITE
						MOV pRSRCBuff,EAX
						MOV pRSRCBuffPos,EAX
						INVOKE RtlMoveMemory,pRSRCBuff,pRSRC,RSRCSize
						MOV EAX,RSRCSize
						ADD pRSRCBuffPos,EAX
						POPAD
					.endif
					PUSHAD
					MOV rPack,0
					MOV EAX,pType
					MOV EBX,offset rawbuffer
					.while DWORD PTR[EBX] != 0
						.if DWORD PTR[EBX] == EAX
							MOV rPack,1
						.endif
						ADD EBX,4
					.endw
					.if rPack == 0
						MOV EAX,pType
						.if EAX > 80000000h
							XOR EAX,80000000h
							ADD EAX,pRSRC
							.if WORD PTR[EAX] > 0
								MOVZX ECX,WORD PTR[EAX]
								ADD EAX,2
								.while ECX > 0 && BYTE PTR[EAX] != 0
									ADD EAX,2
									DEC ECX
								.endw
								.if ECX == NULL
									XOR EDX,EDX
									MOV EAX,pType
									XOR EAX,80000000h
                                                                        ADD EAX,pRSRC
                                                                        ADD EAX,2
                                                                        MOV EBX,EAX
                                                                        MOV EAX,offset szTYPELIB
                                                                        .while BYTE PTR[EAX] != 0
										MOVZX ECX,BYTE PTR[EAX]
										.if CL != BYTE PTR[EBX]
											INC EDX
										.endif
										ADD EBX,2
										ADD EAX,2
                                                                        .endw
                                                                        .if EDX == NULL
										MOV rPack,1
                                                                        .endif
								.endif
							.endif
						.endif
					.endif
					POPAD
					.if pType == 03h || pType == 10h || pType == 0Eh || pType == 18h || rPack == 1
						PUSHAD
						.if ((pType == 03h) && (MAIN_ICON_COUNT > 0)) || (pType != 03h) || rPack == 1
							.if pType == 0Eh && GROUP_ICON == NULL
								INC GROUP_ICON
							.endif
							MOV EAX,MAIN_ICON
							MOV EBX,MAIN_ICON_SIZE
							.if (pName >= EAX && pName < EBX) || pType != 03h
								.if pType == 03h
									DEC MAIN_ICON_COUNT
								.endif
								MOV EAX,pDataRVA
								ADD EAX,ImageBase
								INVOKE ConvertVA2FO,FileMapVA,EAX
								ADD EAX,FileMapVA
								MOV EBX,SizeOfImage
								ADD EBX,1000h
								MOV ECX,hPackedFilePos
								SUB ECX,hPackedFileBuff
								SUB ECX,200h
								ADD ECX,EBX
								MOV EBX,pRSRCBuffPos
								SUB EBX,pRSRCBuff
								ADD ECX,EBX

								.if pType != 0Eh
									PUSHAD
									INVOKE RtlMoveMemory,pRSRCBuffPos,EAX,pSize
									MOV EAX,pSize
									ADD pRSRCBuffPos,EAX
									POPAD
	
									SUB EDX,pRSRC
									ADD EDX,pRSRCBuff
									MOV DWORD PTR[EDX],ECX
								.else
									.if GROUP_ICON == 1
										MOV GROUP_ICON,-1
										PUSHAD
										INVOKE RtlMoveMemory,pRSRCBuffPos,EAX,pSize
										MOV EAX,pSize
										ADD pRSRCBuffPos,EAX
										POPAD
		
										SUB EDX,pRSRC
										ADD EDX,pRSRCBuff
										MOV DWORD PTR[EDX],ECX										
									.endif
								.endif
							.endif
						.endif
						POPAD
					.endif

					ADD ECX,8
					DEC Level3_CNT
				.endw
				ADD EBX,8
				DEC Level2_CNT
                        .endw
			ADD EAX,8
			DEC Level1_CNT
		.endw

		MOV EBX,hPackedFileBuff
		ADD EBX,3Ch
		ADD BX,WORD PTR[EBX]		;WinME/98/95 compatibility!
		SUB BX,3Ch			;

		MOV PEHeader,EBX
	
		MOV EBX,SizeOfImage
		ADD EBX,1000h
		MOV ECX,hPackedFilePos
		SUB ECX,hPackedFileBuff
		SUB ECX,200h
		ADD ECX,EBX

		MOV EAX,pRSRCBuffPos
		SUB EAX,pRSRCBuff
		PUSH EAX
		PUSH pRSRCBuff
		CALL WriteData

		MOV EAX,PEHeader
		MOV DWORD PTR[EAX+88h],ECX
		MOV pRSRCBuffSize,ECX
		MOV ECX,pRSRCBuffPos
		SUB ECX,pRSRCBuff
		MOV DWORD PTR[EAX+8Ch],ECX
		ADD pRSRCBuffSize,ECX
		ADD pRSRCBuffSize,4
		MOV ECX,ImageBase
		ADD pRSRCBuffSize,ECX
	.endif

	POP MAIN_ICON_COUNT
;------------------------------------------------------------------

	MOV EDI,hPackedFilePos
	MOV EAX,PEHeader
	ADD AX,WORD PTR[EAX+14h]
	ADD EAX,18h
	MOV ECX,SizeOfImage
	MOV DWORD PTR[EAX+8],ECX
	ADD EAX,28h
	ADD ECX,1000h
	PUSH ECX
	MOV DWORD PTR[EAX+12],ECX
	MOV ECX,hPackedFilePos
	SUB ECX,hPackedFileBuff
	SUB ECX,200h
	ADD ECX,9000h
	PUSH ECX
	MOV DWORD PTR[EAX+8],ECX
	MOV DWORD PTR[EAX+16],ECX
	MOV ECX,200h
	MOV DWORD PTR[EAX+20],ECX
	POP EDX
	POP ECX
	ADD ECX,EDX
	MOV EAX,PEHeader
	MOV DWORD PTR[EAX+50h],ECX

	.if oStaticDLLImport == 1
		PUSH pRSRCBuffSize
		CALL DWORD PTR[cImporterRelocateWriteLocation]
	
		CALL DWORD PTR[cImporterEstimatedSize]
		MOV ESI,EAX
		ADD ESI,EDI
	
		PUSH hPackedFileBuff
		PUSH pRSRCBuffSize
		CALL DWORD PTR[cImporterExportIAT]
		
		.while BYTE PTR[ESI] == NULL
			DEC ESI
		.endw
		ADD ESI,2
		MOV hPackedFilePos,ESI
	.endif

;------------------------------------------------------------------

	PUSH offset szPackingSections
	CALL _show_log_message
	
	CALL FixPackedHeader

	MOV EBX,FileMapVA
	ADD EBX,3Ch
	ADD BX,WORD PTR[EBX]		;WinME/98/95 compatibility!
	SUB BX,3Ch			;
	MOV PEHeader,EBX

;------------------------------------------------------------------
; Pack sections / aplib
;

	.if Compressor == 1
		MOV FirstSection,0
		MOV EAX,PEHeader
		ADD AX,WORD PTR[EAX+14h]
		ADD EAX,18h
		MOV CurrentSectionOffset,EAX
		MOV ESI,offset PackedSectionTable
		MOV EDI,hPackedFilePos
		.while CurrentSectionNumber > 0
			MOV EBX,CurrentSectionOffset
			MOV ECX,FileMapVA
			ADD EBX,8
			MOV EAX,DWORD PTR[EBX]
			MOV VirtualSize,EAX
			MOV EAX,DWORD PTR[EBX+4]
			MOV VirtualOffset,EAX
			MOV EAX,DWORD PTR[EBX+8]
			MOV RawSize,EAX
			MOV EAX,DWORD PTR[EBX+12]
			MOV RawOffset,EAX
			MOV CompressSectionOffset,EAX
			ADD CompressSectionOffset,ECX
			MOV EAX,DWORD PTR[EBX+1Ch]
			MOV SectionFlags,EAX
	
			SUB EBX,8
			PUSH EBX
			PUSH SectionFlags
			CALL IsSectionPackable
			MOV ECX,CurrentSectionNumber
			SUB ECX,NumberOfSections
			NEG ECX
			INC ECX
			.if ECX == RSRCSectionNumber
				MOV EAX,3
			.endif
			.if RawSize > 0
				.if EAX == 1
					CALL initProgress
					.if FirstSection == 0
						PUSHAD
						MOV EAX,VirtualOffset
						ADD EAX,ImageBase
						INVOKE FilterCode,EAX,CompressSectionOffset,RawSize
						MOV EAX,VirtualOffset
						MOV FirstSectionOffset,EAX
						MOV EAX,RawSize
						MOV FirstSectionSize,EAX
						MOV FirstSection,1
						POPAD
					.endif
					MOV DWORD PTR[ESI],EDI
					ADD ESI,4
					MOV EAX,VirtualOffset
;					ADD EAX,ImageBase
					MOV DWORD PTR[ESI],EAX
					ADD ESI,4
	
					INVOKE aP_max_packed_size,RawSize
					MOV OutMemBuffSize,EAX
		
					INVOKE VirtualAlloc,NULL,EAX,MEM_COMMIT,PAGE_EXECUTE_READWRITE
		
					MOV OutMemBuff,EAX
					INVOKE aP_workmem_size,RawSize
					MOV WorkMemSize,EAX
		
					INVOKE VirtualAlloc,NULL,EAX,MEM_COMMIT,PAGE_EXECUTE_READWRITE
		
					MOV WorkMemBuff,EAX
		
					INVOKE aP_pack,CompressSectionOffset,OutMemBuff,RawSize,WorkMemBuff,addr cProgress,NULL
					ADD EAX,4
					MOV PackedSize,EAX
					ADD EDI,PackedSize
	
					INVOKE VirtualFree,WorkMemBuff,WorkMemSize,MEM_DECOMMIT
					PUSH PackedSize
					PUSH OutMemBuff
					CALL WriteData
		
					INVOKE VirtualFree,OutMemBuff,OutMemBuffSize,MEM_DECOMMIT
				.elseif EAX == 2
					NOP
				.elseif EAX == 3
					.if oStripRSRC == 0
						CALL RSRCPack
					.endif
					CALL initProgress			
					MOV DWORD PTR[ESI],EDI
					ADD ESI,4
					MOV EAX,VirtualOffset
;					ADD EAX,ImageBase
					MOV DWORD PTR[ESI],EAX
					ADD ESI,4
		
					INVOKE aP_max_packed_size,RawSize
					MOV OutMemBuffSize,EAX
		
					INVOKE VirtualAlloc,NULL,EAX,MEM_COMMIT,PAGE_EXECUTE_READWRITE
		
					MOV OutMemBuff,EAX
					INVOKE aP_workmem_size,RawSize
					MOV WorkMemSize,EAX
		
					INVOKE VirtualAlloc,NULL,EAX,MEM_COMMIT,PAGE_EXECUTE_READWRITE
		
					MOV WorkMemBuff,EAX
		
					INVOKE aP_pack,CompressSectionOffset,OutMemBuff,RawSize,WorkMemBuff,addr cProgress,NULL
					ADD EAX,4
					MOV PackedSize,EAX
					ADD EDI,PackedSize
		
					INVOKE VirtualFree,WorkMemBuff,WorkMemSize,MEM_DECOMMIT
					PUSH PackedSize
					PUSH OutMemBuff
					CALL WriteData
		
					INVOKE VirtualFree,OutMemBuff,OutMemBuffSize,MEM_DECOMMIT
					INVOKE VirtualFree,pRSRC,pSize,MEM_DECOMMIT
				.elseif EAX == 4
					MOV DWORD PTR[ESI],EDI
					ADD ESI,4
					MOV EAX,VirtualOffset
;					ADD EAX,ImageBase
					MOV DWORD PTR[ESI],EAX
					ADD ESI,4
					INVOKE CompressRelocations,CompressSectionOffset,RawSize
					MOV RawSize,EBX
					MOV CompressSectionOffset,EAX
					
					INVOKE aP_max_packed_size,RawSize
					MOV OutMemBuffSize,EAX
		
					INVOKE VirtualAlloc,NULL,EAX,MEM_COMMIT,PAGE_EXECUTE_READWRITE
		
					MOV OutMemBuff,EAX
					INVOKE aP_workmem_size,RawSize
					MOV WorkMemSize,EAX
		
					INVOKE VirtualAlloc,NULL,EAX,MEM_COMMIT,PAGE_EXECUTE_READWRITE
		
					MOV WorkMemBuff,EAX
		
					INVOKE aP_pack,CompressSectionOffset,OutMemBuff,RawSize,WorkMemBuff,addr cProgress,NULL
					ADD EAX,4
					MOV PackedSize,EAX
					ADD EDI,PackedSize
		
					INVOKE VirtualFree,WorkMemBuff,WorkMemSize,MEM_DECOMMIT
					PUSH PackedSize
					PUSH OutMemBuff
					CALL WriteData
		
					INVOKE VirtualFree,OutMemBuff,OutMemBuffSize,MEM_DECOMMIT
					INVOKE VirtualFree,CompressSectionOffset,RawSize,MEM_DECOMMIT
				.else
					ADD EDI,RawSize
		
					PUSH RawSize
					PUSH CompressSectionOffset
					CALL WriteData
				.endif
			.endif
			ADD CurrentSectionOffset,28h
			DEC CurrentSectionNumber
		.endw
	.endif

;------------------------------------------------------------------
; Pack sections / lzma
;

	.if Compressor == 2
		MOV FirstSection,0
		MOV EAX,PEHeader
		ADD AX,WORD PTR[EAX+14h]
		ADD EAX,18h
		MOV CurrentSectionOffset,EAX
		MOV ESI,offset PackedSectionTable
		MOV EDI,hPackedFilePos
		.while CurrentSectionNumber > 0
			MOV EBX,CurrentSectionOffset
			MOV ECX,FileMapVA
			ADD EBX,8
			MOV EAX,DWORD PTR[EBX]
			MOV VirtualSize,EAX
			MOV EAX,DWORD PTR[EBX+4]
			MOV VirtualOffset,EAX
			MOV EAX,DWORD PTR[EBX+8]
			MOV RawSize,EAX
			MOV EAX,DWORD PTR[EBX+12]
			MOV RawOffset,EAX
			MOV CompressSectionOffset,EAX
			ADD CompressSectionOffset,ECX
			MOV EAX,DWORD PTR[EBX+1Ch]
			MOV SectionFlags,EAX
	
			SUB EBX,8
			PUSH EBX
			PUSH SectionFlags
			CALL IsSectionPackable
			MOV ECX,CurrentSectionNumber
			SUB ECX,NumberOfSections
			NEG ECX
			INC ECX
			.if ECX == RSRCSectionNumber
				MOV EAX,3
			.endif
			.if RawSize > 0
				.if EAX == 1
					CALL initProgress
					.if FirstSection == 0
						PUSHAD
						MOV EAX,VirtualOffset
						ADD EAX,ImageBase
						INVOKE FilterCode,EAX,CompressSectionOffset,RawSize
						MOV EAX,VirtualOffset
						MOV FirstSectionOffset,EAX
						MOV EAX,RawSize
						MOV FirstSectionSize,EAX
						MOV FirstSection,1
						POPAD
					.endif
					MOV DWORD PTR[ESI],EDI
					ADD ESI,4
					MOV EAX,VirtualOffset
;					ADD EAX,ImageBase
					MOV DWORD PTR[ESI],EAX
					ADD ESI,4
		
					MOV EAX,RawSize
					ADD EAX,1024
					MOV OutMemBuffSize,EAX

					INVOKE VirtualAlloc,NULL,EAX,MEM_COMMIT,PAGE_EXECUTE_READWRITE

					MOV OutMemBuff,EAX
		
					INVOKE CompressSection,OutMemBuff,CompressSectionOffset,RawSize
					ADD EAX,4
					MOV PackedSize,EAX
					ADD EDI,PackedSize
		
					PUSH PackedSize
					PUSH OutMemBuff
					CALL WriteData

					INVOKE VirtualFree,OutMemBuff,OutMemBuffSize,MEM_DECOMMIT
				.elseif EAX == 2
					NOP
				.elseif EAX == 3
					.if oStripRSRC == 0
						CALL RSRCPack
					.endif
					CALL initProgress			
					MOV DWORD PTR[ESI],EDI
					ADD ESI,4
					MOV EAX,VirtualOffset
;					ADD EAX,ImageBase
					MOV DWORD PTR[ESI],EAX
					ADD ESI,4

					MOV EAX,RawSize
					ADD EAX,1024
					MOV OutMemBuffSize,EAX

					INVOKE VirtualAlloc,NULL,EAX,MEM_COMMIT,PAGE_EXECUTE_READWRITE

					MOV OutMemBuff,EAX

					INVOKE CompressSection,OutMemBuff,CompressSectionOffset,RawSize
					ADD EAX,4
					MOV PackedSize,EAX
					ADD EDI,PackedSize

					PUSH PackedSize
					PUSH OutMemBuff
					CALL WriteData

					INVOKE VirtualFree,OutMemBuff,OutMemBuffSize,MEM_DECOMMIT
					INVOKE VirtualFree,pRSRC,pSize,MEM_DECOMMIT
				.elseif EAX == 4
					MOV DWORD PTR[ESI],EDI
					ADD ESI,4
					MOV EAX,VirtualOffset
;					ADD EAX,ImageBase
					MOV DWORD PTR[ESI],EAX
					ADD ESI,4
					INVOKE CompressRelocations,CompressSectionOffset,RawSize
					MOV RawSize,EBX
					MOV CompressSectionOffset,EAX
					
					MOV EAX,RawSize
					ADD EAX,1024
					MOV OutMemBuffSize,EAX

					INVOKE VirtualAlloc,NULL,EAX,MEM_COMMIT,PAGE_EXECUTE_READWRITE

					MOV OutMemBuff,EAX

					INVOKE CompressSection,OutMemBuff,CompressSectionOffset,RawSize
					ADD EAX,4
					MOV PackedSize,EAX
					ADD EDI,PackedSize

					PUSH PackedSize
					PUSH OutMemBuff
					CALL WriteData

					INVOKE VirtualFree,OutMemBuff,OutMemBuffSize,MEM_DECOMMIT
					INVOKE VirtualFree,CompressSectionOffset,RawSize,MEM_DECOMMIT
				.else
					ADD EDI,RawSize
		
					PUSH RawSize
					PUSH CompressSectionOffset
					CALL WriteData
				.endif
			.endif
			ADD CurrentSectionOffset,28h
			DEC CurrentSectionNumber
		.endw
	.endif

;------------------------------------------------------------------
; Fix packed file PEHeader
;
;

	MOV EBX,hPackedFileBuff
	ADD EBX,3Ch
	ADD BX,WORD PTR[EBX]		;WinME/98/95 compatibility!
	SUB BX,3Ch			;

	MOV PEHeader,EBX

	MOV EAX,TimeDateStamp
	MOV DWORD PTR[EBX+8h],EAX
	MOV EAX,Characteristics
	MOV DWORD PTR[EBX+16h],EAX
	MOV EAX,SubSytem
	MOV WORD PTR[EBX+5Ch],AX
	MOV EAX,ImageBase
	MOV DWORD PTR[EBX+34h],EAX
	.if Shareable == 1
		PUSH EBX
		ADD BX,WORD PTR[EBX+14h]
		ADD EBX,18h
		MOV DWORD PTR[EBX+24h],070000020h
		POP EBX
	.endif
	MOV EAX,DelayImportTable
	MOV DWORD PTR[EBX+0E0h],EAX
	MOV EAX,DelayImportTableSize
	MOV DWORD PTR[EBX+0E4h],EAX

	CALL FixPackedHeader

;------------------------------------------------------------------
; Pack export table
;

	.if oExportTable == 0 || IsDll == 1
		MOV EAX,FileMapVA
		ADD EAX,3Ch
		ADD AX,WORD PTR[EAX]		;WinME/98/95 compatibility!
		SUB AX,3Ch
		MOV EBX,DWORD PTR[EAX+78h]
		MOV ECX,DWORD PTR[EAX+7Ch]
		.if EBX > 0 && ECX > 0
			PUSH offset szPackingExport
			CALL _show_log_message

			MOV orgExportAddr,EBX
			MOV orgExportSize,ECX

			ADD EBX,ImageBase
			INVOKE ConvertVA2FO,FileMapVA,EBX
			MOV EBX,EAX
			ADD EBX,FileMapVA

			PUSHAD
			MOV ExportTableBuffSize,ECX
			INVOKE VirtualAlloc,NULL,ECX,MEM_COMMIT,PAGE_EXECUTE_READWRITE
			MOV ExportTableBuff,EAX
			POPAD

			INVOKE RtlMoveMemory,ExportTableBuff,EBX,ExportTableBuffSize

			MOV EAX,hPackedFilePos
			INVOKE ConvertFO2VA,hPackedFileBuff,EAX
			MOV ESI,EAX

			MOV EAX,hPackedFileBuff
			ADD EAX,3Ch
			ADD AX,WORD PTR[EAX]		;WinME/98/95 compatibility!
			SUB AX,3Ch			;
			ADD EAX,78h
			MOV DWORD PTR[EAX],ESI
			MOV ECX,orgExportSize
			MOV DWORD PTR[EAX+4],ECX

			MOV EAX,ExportTableBuff
			MOV EBX,DWORD PTR[EAX+32]	;Name Pointer RVA
			SUB EBX,orgExportAddr
			ADD EBX,ExportTableBuff
			MOV ECX,DWORD PTR[EAX+24]	;Number of Name Pointers
			.while ECX > 0
				MOV EDX,DWORD PTR[EBX]
				SUB EDX,orgExportAddr
				ADD EDX,ESI
                                MOV DWORD PTR[EBX],EDX
                                ADD EBX,4
				DEC ECX
			.endw

			MOV EBX,DWORD PTR[EAX+12]	;Name RVA
			SUB EBX,orgExportAddr
			ADD EBX,ESI
			MOV DWORD PTR[EAX+12],EBX
			MOV EBX,DWORD PTR[EAX+28]	;Export Address Table RVA
			SUB EBX,orgExportAddr
			ADD EBX,ESI
			MOV DWORD PTR[EAX+28],EBX
			MOV EBX,DWORD PTR[EAX+32]	;Name Pointer RVA
			SUB EBX,orgExportAddr
			ADD EBX,ESI
			MOV DWORD PTR[EAX+32],EBX
			MOV EBX,DWORD PTR[EAX+36]	;Ordinal Table RVA
			SUB EBX,orgExportAddr
			ADD EBX,ESI
			MOV DWORD PTR[EAX+36],EBX

			PUSH ExportTableBuffSize
			PUSH ExportTableBuff
			CALL WriteData

			INVOKE VirtualFree,ExportTableBuff,ExportTableBuffSize,MEM_DECOMMIT
		       	CALL FixPackedHeader
		.endif
	.endif

;------------------------------------------------------------------
; Copy STUB and fill it with data / aplib
;

	.if Compressor == 1
		MOV EAX,hPackedFilePos
		MOV STUB_OEP,EAX
		MOV STUB_OEP_OFFSET,EAX
	
		.if IsDll == 0
			MOV EAX,offset __STUB_END
			SUB EAX,offset __STUB_START
			PUSH EAX
			PUSH offset __STUB_START
			CALL WriteData
		.else
			MOV EAX,offset __STUB_END
			SUB EAX,offset __DLL_STUB_START
			PUSH EAX
			PUSH offset __DLL_STUB_START
			CALL WriteData
		.endif

		MOV EAX,hPackedFilePos

		MOV EDX,offset STUB_DATA
		ADD EDX,12			;SectionData pointer
		
		MOV ECX,ImageBase
		MOV EBX,offset PackedSectionTable
		.while DWORD PTR[EBX] != 0
			INVOKE ConvertFO2VA,hPackedFileBuff,DWORD PTR[EBX]
			MOV DWORD PTR[EDX],EAX
;			ADD DWORD PTR[EDX],ECX
			ADD EDX,4
			MOV EAX,DWORD PTR[EBX+4]
			MOV DWORD PTR[EDX],EAX
			ADD EDX,4
			ADD EBX,8
		.endw
		SUB EDX,offset STUB_DATA
		ADD EDX,4
		PUSH EDX
		PUSH offset STUB_DATA
		CALL WriteData
	.endif

;------------------------------------------------------------------
; Copy STUB and fill it with data / lzma
;

	.if Compressor == 2
		MOV EAX,hPackedFilePos
		MOV STUB_OEP,EAX
		MOV STUB_OEP_OFFSET,EAX
	
		.if IsDll == 0
			MOV EAX,offset __L_STUB_END
			SUB EAX,offset __L_STUB_START
			PUSH EAX
			PUSH offset __L_STUB_START
			CALL WriteData
		.else
			MOV EAX,offset __L_STUB_END
			SUB EAX,offset __L_DLL_STUB_START
			PUSH EAX
			PUSH offset __L_DLL_STUB_START
			CALL WriteData
		.endif

		MOV EAX,hPackedFilePos

		MOV EDX,offset STUB_DATA
		ADD EDX,12			;SectionData pointer

		MOV ECX,ImageBase
		MOV EBX,offset PackedSectionTable
		.while DWORD PTR[EBX] != 0
			INVOKE ConvertFO2VA,hPackedFileBuff,DWORD PTR[EBX]
			MOV DWORD PTR[EDX],EAX
;			ADD DWORD PTR[EDX],ECX
			ADD EDX,4
			MOV EAX,DWORD PTR[EBX+4]
			MOV DWORD PTR[EDX],EAX
			ADD EDX,4
			ADD EBX,8
		.endw
		SUB EDX,offset STUB_DATA
		ADD EDX,4
		PUSH EDX
		PUSH offset STUB_DATA
		CALL WriteData
	.endif

;------------------------------------------------------------------
; Copy IAT / aplib
;

	.if Compressor == 1
		MOV EAX,APINameBuff
		SUB EAX,APINameBuff_Base
		MOV RawSize,EAX
		MOV EBX,DLLNameBuff
		MOV BYTE PTR[EBX],1
		INC DLLNameBuff
		INVOKE RtlMoveMemory,DLLNameBuff,APINameBuff_Base,RawSize
		MOV EAX,DLLNameBuff
		SUB EAX,DLLNameBuff_Base
		ADD RawSize,EAX
	
		INVOKE aP_max_packed_size,RawSize
		MOV OutMemBuffSize,EAX
	
		INVOKE VirtualAlloc,NULL,EAX,MEM_COMMIT,PAGE_EXECUTE_READWRITE
	
		MOV OutMemBuff,EAX
		INVOKE aP_workmem_size,RawSize
		MOV WorkMemSize,EAX
	
		INVOKE VirtualAlloc,NULL,EAX,MEM_COMMIT,PAGE_EXECUTE_READWRITE
	
		MOV WorkMemBuff,EAX
	
		INVOKE aP_pack,DLLNameBuff_Base,OutMemBuff,RawSize,WorkMemBuff,NULL,NULL
		ADD EAX,4
		MOV PackedSize,EAX
	
		INVOKE VirtualFree,WorkMemBuff,WorkMemSize,MEM_DECOMMIT
		PUSH PackedSize
		PUSH OutMemBuff
		CALL WriteData
	
		INVOKE VirtualFree,OutMemBuff,OutMemBuffSize,MEM_DECOMMIT
	       	CALL FixPackedHeader
	.endif

;------------------------------------------------------------------
; Copy IAT / lzma
;

	.if Compressor == 2
		MOV EAX,APINameBuff
		SUB EAX,APINameBuff_Base
		MOV RawSize,EAX
		MOV EBX,DLLNameBuff
		MOV BYTE PTR[EBX],1
		INC DLLNameBuff
		INVOKE RtlMoveMemory,DLLNameBuff,APINameBuff_Base,RawSize
		MOV EAX,DLLNameBuff
		SUB EAX,DLLNameBuff_Base
		ADD RawSize,EAX
	
		MOV EAX,RawSize
		ADD EAX,1024
		MOV OutMemBuffSize,EAX
	
		INVOKE VirtualAlloc,NULL,EAX,MEM_COMMIT,PAGE_EXECUTE_READWRITE
	
		MOV OutMemBuff,EAX
	
		INVOKE CompressSection,OutMemBuff,DLLNameBuff_Base,RawSize
		ADD EAX,4
		MOV PackedSize,EAX
	
		PUSH PackedSize
		PUSH OutMemBuff
		CALL WriteData
	
		INVOKE VirtualFree,OutMemBuff,OutMemBuffSize,MEM_DECOMMIT
	       	CALL FixPackedHeader
	.endif

;------------------------------------------------------------------
; Copy TLS
;
;
	.if oStripTLS == 0
		MOV EBX,FileMapVA
		ADD EBX,3Ch
		ADD BX,WORD PTR[EBX]		;WinME/98/95 compatibility!
		SUB BX,3Ch			;

		MOV PEHeader,EBX
	
		MOV EBX,SizeOfImage
		ADD EBX,1000h
		MOV ECX,hPackedFilePos
		SUB ECX,hPackedFileBuff
		SUB ECX,200h
		ADD ECX,EBX
	
		MOV EBX,PEHeader
		MOV ESI,DWORD PTR[EBX+0C0h]
		MOV EDI,DWORD PTR[EBX+0C4h]
		ADD ESI,ImageBase
		INVOKE ConvertVA2FO,FileMapVA,ESI
		ADD EAX,FileMapVA
		MOV ESI,EAX
	
		.if ESI > 0 && EDI > 0
			PUSH EDI
			PUSH ESI
			CALL WriteData
		.endif
	
		MOV EBX,hPackedFileBuff
		ADD EBX,3Ch
		ADD BX,WORD PTR[EBX]		;WinME/98/95 compatibility!
		SUB BX,3Ch			;

		MOV PEHeader,EBX
	
		.if ESI > 0 && EDI > 0
			MOV EAX,PEHeader
			MOV DWORD PTR[EAX+0C0h],ECX
			MOV DWORD PTR[EAX+0C4h],EDI
			.if Shareable == 1
				PUSH EAX
				ADD AX,WORD PTR[EAX+14h]
				ADD EAX,18h
				MOV DWORD PTR[EAX+24h],0F0000020h
				POP EAX
			.else
				PUSH EAX
				ADD AX,WORD PTR[EAX+14h]
				ADD EAX,18h
				MOV DWORD PTR[EAX+24h],0E0000020h
				POP EAX
			.endif
		.endif
	.endif
       	CALL FixPackedHeader

;------------------------------------------------------------------
; Fix OEP and IAT / aplib
;

	.if Compressor == 1 && IsDll == 0
		INVOKE ConvertFO2VA,hPackedFileBuff,STUB_OEP
		MOV EBX,PEHeader
		ADD EBX,28h
		MOV DWORD PTR[EBX],EAX
		
		MOV ESI,EAX
		ADD ESI,ImageBase

		MOV EDX,STUB_OEP_OFFSET
		LEA EBX,DWORD PTR[EDX+((offset __kernel32 - offset __STUB_START))]
		LEA ECX,DWORD PTR[EDX+((offset __dllName - offset __STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX

		LEA EBX,DWORD PTR[EDX+((offset __locloadlib - offset __STUB_START))]
		LEA ECX,DWORD PTR[EDX+((offset __FirstThunk - offset __STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __loadlib - offset __STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __locloadlib - offset __STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __gpa - offset __STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __locgpa - offset __STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __va - offset __STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __locva - offset __STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __vf - offset __STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __locvf - offset __STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
		
		LEA EBX,DWORD PTR[EDX+((offset __vp - offset __STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __locvp - offset __STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA ECX,DWORD PTR[EDX+((offset __PE32_IMAGEBASE - offset __STUB_START))]
		MOV EAX,ImageBase
		MOV DWORD PTR[ECX],EAX
		LEA ECX,DWORD PTR[EDX+((offset __RELOCATION - offset __STUB_START))]
		MOV EAX,RelocationRVA
		MOV DWORD PTR[ECX],EAX
		LEA ECX,DWORD PTR[EDX+((offset __FILTER_CODE_START - offset __STUB_START))]
		MOV EAX,FirstSectionOffset
		MOV DWORD PTR[ECX],EAX
		LEA ECX,DWORD PTR[EDX+((offset __FILTER_CODE_SIZE - offset __STUB_START))]
		MOV EAX,FirstSectionSize
		MOV DWORD PTR[ECX],EAX
		LEA ECX,DWORD PTR[EDX+((offset __FILTER_CODE_BYTE - offset __STUB_START))]
		MOV EAX,FilterByte
		MOV DWORD PTR[ECX],EAX

		LEA EBX,DWORD PTR[EDX+((offset __STUB_OEP_JUMP - offset __STUB_START))+1]
		LEA ECX,DWORD PTR[EDX+((offset __STUB_OEP_JUMP - offset __STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,ECX
		ADD EAX,ImageBase
		MOV ECX,PackedOEP
		SUB ECX,EAX
		SUB ECX,5
		MOV DWORD PTR[EBX],ECX

		MOV EAX,RawSize
		LEA EBX,DWORD PTR[EDX+((offset __STUB_VA_SIZE - offset __STUB_START))+1]
		MOV DWORD PTR[EBX],EAX
		LEA EBX,DWORD PTR[EDX+((offset __STUB_VF_SIZE - offset __STUB_START))+1]
		MOV DWORD PTR[EBX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __iat - offset __STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX

		MOV EBX,PEHeader
		.if oStaticDLLImport == NULL
			MOV DWORD PTR[EBX+80h],EAX
			MOV DWORD PTR[EBX+84h],28h
		.endif
	.endif

;------------------------------------------------------------------
; Fix OEP and IAT / lzma
;

	.if Compressor == 2 && IsDll == 0
		INVOKE ConvertFO2VA,hPackedFileBuff,STUB_OEP
		MOV EBX,PEHeader
		ADD EBX,28h
		MOV DWORD PTR[EBX],EAX
		
		MOV ESI,EAX
		ADD ESI,ImageBase
	
		MOV EDX,STUB_OEP_OFFSET
		LEA EBX,DWORD PTR[EDX+((offset __L_kernel32 - offset __L_STUB_START))]
		LEA ECX,DWORD PTR[EDX+((offset __L_dllName_k - offset __L_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __L_locloadlib - offset __L_STUB_START))]
		LEA ECX,DWORD PTR[EDX+((offset __L_FirstThunk_k - offset __L_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX

		LEA EBX,DWORD PTR[EDX+((offset __L_loadlib - offset __L_STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __L_locloadlib - offset __L_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __L_gpa - offset __L_STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __L_locgpa - offset __L_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __L_va - offset __L_STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __L_locva - offset __L_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __L_vf - offset __L_STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __L_locvf - offset __L_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
		
		LEA EBX,DWORD PTR[EDX+((offset __L_vp - offset __L_STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __L_locvp - offset __L_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA ECX,DWORD PTR[EDX+((offset __L_PE32_IMAGEBASE - offset __L_STUB_START))]
		MOV EAX,ImageBase
		MOV DWORD PTR[ECX],EAX
		LEA ECX,DWORD PTR[EDX+((offset __L_RELOCATION - offset __L_STUB_START))]
		MOV EAX,RelocationRVA
		MOV DWORD PTR[ECX],EAX
		LEA ECX,DWORD PTR[EDX+((offset __L_FILTER_CODE_START - offset __L_STUB_START))]
		MOV EAX,FirstSectionOffset
		MOV DWORD PTR[ECX],EAX
		LEA ECX,DWORD PTR[EDX+((offset __L_FILTER_CODE_SIZE - offset __L_STUB_START))]
		MOV EAX,FirstSectionSize
		MOV DWORD PTR[ECX],EAX
		LEA ECX,DWORD PTR[EDX+((offset __L_FILTER_CODE_BYTE - offset __L_STUB_START))]
		MOV EAX,FilterByte
		MOV DWORD PTR[ECX],EAX

		LEA EBX,DWORD PTR[EDX+((offset __L_STUB_OEP_JUMP - offset __L_STUB_START))+1]
		LEA ECX,DWORD PTR[EDX+((offset __L_STUB_OEP_JUMP - offset __L_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,ECX
		ADD EAX,ImageBase
		MOV ECX,PackedOEP
		SUB ECX,EAX
		SUB ECX,5
		MOV DWORD PTR[EBX],ECX

		MOV EAX,RawSize
		LEA EBX,DWORD PTR[EDX+((offset __L_STUB_VA_SIZE - offset __L_STUB_START))+1]
		MOV DWORD PTR[EBX],EAX
		LEA EBX,DWORD PTR[EDX+((offset __L_STUB_VF_SIZE - offset __L_STUB_START))+1]
		MOV DWORD PTR[EBX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __L_iat - offset __L_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX

		MOV EBX,PEHeader
		.if oStaticDLLImport == NULL
			MOV DWORD PTR[EBX+80h],EAX
			MOV DWORD PTR[EBX+84h],28h
		.endif
	.endif

;------------------------------------------------------------------
; Fix OEP and IAT / aplib
;

	.if Compressor == 1 && IsDll == 1
		INVOKE ConvertFO2VA,hPackedFileBuff,STUB_OEP
		MOV EBX,PEHeader
		ADD EBX,28h
		MOV DWORD PTR[EBX],EAX
		
		MOV ESI,EAX
		ADD ESI,ImageBase

		MOV EDX,STUB_OEP_OFFSET
		LEA EBX,DWORD PTR[EDX+((offset __kernel32 - offset __DLL_STUB_START))]
		LEA ECX,DWORD PTR[EDX+((offset __dllName - offset __DLL_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX

		LEA EBX,DWORD PTR[EDX+((offset __locloadlib - offset __DLL_STUB_START))]
		LEA ECX,DWORD PTR[EDX+((offset __FirstThunk - offset __DLL_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __loadlib - offset __DLL_STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __locloadlib - offset __DLL_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __gpa - offset __DLL_STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __locgpa - offset __DLL_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __va - offset __DLL_STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __locva - offset __DLL_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __vf - offset __DLL_STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __locvf - offset __DLL_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
		
		LEA EBX,DWORD PTR[EDX+((offset __vp - offset __DLL_STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __locvp - offset __DLL_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA ECX,DWORD PTR[EDX+((offset __PE32_IMAGEBASE - offset __DLL_STUB_START))]
		MOV EAX,ImageBase
		MOV DWORD PTR[ECX],EAX
		LEA ECX,DWORD PTR[EDX+((offset __RELOCATION - offset __DLL_STUB_START))]
		MOV EAX,RelocationRVA
		MOV DWORD PTR[ECX],EAX
		LEA ECX,DWORD PTR[EDX+((offset __FILTER_CODE_START - offset __DLL_STUB_START))]
		MOV EAX,FirstSectionOffset
		MOV DWORD PTR[ECX],EAX
		LEA ECX,DWORD PTR[EDX+((offset __FILTER_CODE_SIZE - offset __DLL_STUB_START))]
		MOV EAX,FirstSectionSize
		MOV DWORD PTR[ECX],EAX
		LEA ECX,DWORD PTR[EDX+((offset __FILTER_CODE_BYTE - offset __DLL_STUB_START))]
		MOV EAX,FilterByte
		MOV DWORD PTR[ECX],EAX

		MOV EAX,PackedOEP
		.if EAX != ImageBase
			LEA EBX,DWORD PTR[EDX+((offset __STUB_OEP_JUMP - offset __DLL_STUB_START))+1]
			LEA ECX,DWORD PTR[EDX+((offset __STUB_OEP_JUMP - offset __DLL_STUB_START))]
			INVOKE ConvertFO2VA,hPackedFileBuff,ECX
			ADD EAX,ImageBase
			MOV ECX,PackedOEP
			SUB ECX,EAX
			SUB ECX,5
			MOV DWORD PTR[EBX],ECX
		.else
			LEA EBX,DWORD PTR[EDX+((offset __STUB_OEP_JUMP - offset __DLL_STUB_START))]
			MOV DWORD PTR[EBX],0C240C033h
			MOV WORD PTR[EBX+4],0Ch
		.endif

		MOV EAX,RawSize
		LEA EBX,DWORD PTR[EDX+((offset __STUB_VA_SIZE - offset __DLL_STUB_START))+1]
		MOV DWORD PTR[EBX],EAX
		LEA EBX,DWORD PTR[EDX+((offset __STUB_VF_SIZE - offset __DLL_STUB_START))+1]
		MOV DWORD PTR[EBX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __iat - offset __DLL_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX

		MOV EBX,PEHeader
		.if oStaticDLLImport == NULL
			MOV DWORD PTR[EBX+080h],EAX
			MOV DWORD PTR[EBX+084h],28h
		.endif
		LEA EAX,DWORD PTR[EDX+((offset __WIN9x_RELOCATION - offset __DLL_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EAX
		MOV DWORD PTR[EBX+0A0h],EAX
		MOV DWORD PTR[EBX+0A4h],8
	.endif

;------------------------------------------------------------------
; Fix OEP and IAT / lzma
;

	.if Compressor == 2 && IsDll == 1
		INVOKE ConvertFO2VA,hPackedFileBuff,STUB_OEP
		MOV EBX,PEHeader
		ADD EBX,28h
		MOV DWORD PTR[EBX],EAX
		
		MOV ESI,EAX
		ADD ESI,ImageBase
	
		MOV EDX,STUB_OEP_OFFSET
		LEA EBX,DWORD PTR[EDX+((offset __L_kernel32 - offset __L_DLL_STUB_START))]
		LEA ECX,DWORD PTR[EDX+((offset __L_dllName_k - offset __L_DLL_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __L_locloadlib - offset __L_DLL_STUB_START))]
		LEA ECX,DWORD PTR[EDX+((offset __L_FirstThunk_k - offset __L_DLL_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX

		LEA EBX,DWORD PTR[EDX+((offset __L_loadlib - offset __L_DLL_STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __L_locloadlib - offset __L_DLL_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __L_gpa - offset __L_DLL_STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __L_locgpa - offset __L_DLL_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __L_va - offset __L_DLL_STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __L_locva - offset __L_DLL_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __L_vf - offset __L_DLL_STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __L_locvf - offset __L_DLL_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
		
		LEA EBX,DWORD PTR[EDX+((offset __L_vp - offset __L_DLL_STUB_START))-2]
		LEA ECX,DWORD PTR[EDX+((offset __L_locvp - offset __L_DLL_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX
		MOV DWORD PTR[ECX],EAX
	
		LEA ECX,DWORD PTR[EDX+((offset __L_PE32_IMAGEBASE - offset __L_DLL_STUB_START))]
		MOV EAX,ImageBase
		MOV DWORD PTR[ECX],EAX
		LEA ECX,DWORD PTR[EDX+((offset __L_RELOCATION - offset __L_DLL_STUB_START))]
		MOV EAX,RelocationRVA
		MOV DWORD PTR[ECX],EAX
		LEA ECX,DWORD PTR[EDX+((offset __L_FILTER_CODE_START - offset __L_DLL_STUB_START))]
		MOV EAX,FirstSectionOffset
		MOV DWORD PTR[ECX],EAX
		LEA ECX,DWORD PTR[EDX+((offset __L_FILTER_CODE_SIZE - offset __L_DLL_STUB_START))]
		MOV EAX,FirstSectionSize
		MOV DWORD PTR[ECX],EAX
		LEA ECX,DWORD PTR[EDX+((offset __L_FILTER_CODE_BYTE - offset __L_DLL_STUB_START))]
		MOV EAX,FilterByte
		MOV DWORD PTR[ECX],EAX

		MOV EAX,PackedOEP
		.if EAX != ImageBase
			LEA EBX,DWORD PTR[EDX+((offset __L_STUB_OEP_JUMP - offset __L_DLL_STUB_START))+1]
			LEA ECX,DWORD PTR[EDX+((offset __L_STUB_OEP_JUMP - offset __L_DLL_STUB_START))]
			INVOKE ConvertFO2VA,hPackedFileBuff,ECX
			ADD EAX,ImageBase
			MOV ECX,PackedOEP
			SUB ECX,EAX
			SUB ECX,5
			MOV DWORD PTR[EBX],ECX
		.else
			LEA EBX,DWORD PTR[EDX+((offset __L_STUB_OEP_JUMP - offset __L_DLL_STUB_START))]
			MOV DWORD PTR[EBX],0C240C033h
			MOV WORD PTR[EBX+4],0Ch
		.endif

		MOV EAX,RawSize
		LEA EBX,DWORD PTR[EDX+((offset __L_STUB_VA_SIZE - offset __L_DLL_STUB_START))+1]
		MOV DWORD PTR[EBX],EAX
		LEA EBX,DWORD PTR[EDX+((offset __L_STUB_VF_SIZE - offset __L_DLL_STUB_START))+1]
		MOV DWORD PTR[EBX],EAX
	
		LEA EBX,DWORD PTR[EDX+((offset __L_iat - offset __L_DLL_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EBX

		MOV EBX,PEHeader
		.if oStaticDLLImport == NULL
			MOV DWORD PTR[EBX+80h],EAX
			MOV DWORD PTR[EBX+84h],28h
		.endif
		LEA EAX,DWORD PTR[EDX+((offset __L_WIN9x_RELOCATION - offset __L_DLL_STUB_START))]
		INVOKE ConvertFO2VA,hPackedFileBuff,EAX
		MOV DWORD PTR[EBX+0A0h],EAX
		MOV DWORD PTR[EBX+0A4h],8
	.endif

;------------------------------------------------------------------
; Write packed file to disk
;
;
	INVOKE UnmapFile

	INVOKE CreateOutFile,addr szOpenFileName
	MOV EAX,hPackedFilePos
	SUB EAX,hPackedFileBuff
	INVOKE WriteFile,hPackedFile,hPackedFileBuff,EAX,addr NumberOfBytesWritten,NULL
	INVOKE CloseOutFile

;------------------------------------------------------------------
; Copy Overlay
;

	.if oOverlay == 1 && OverlayExists > 0
		PUSH offset szSaveOverlay
		CALL _show_log_message
		INVOKE AddOverlay,addr szOpenFileName,addr szTMP
		INVOKE DeleteFile,addr szTMP
	.endif

;------------------------------------------------------------------
; Free memory
;
;

	INVOKE VirtualFree,pRSRCBuff,pRSRCBuffSize,MEM_DECOMMIT
	INVOKE VirtualFree,DLLNameBuff_Base,500000h,MEM_DECOMMIT
	INVOKE VirtualFree,APINameBuff_Base,500000h,MEM_DECOMMIT

	MOV EAX,FileSize
	ADD EAX,500000h
	INVOKE VirtualFree,hPackedFileBuff,EAX,MEM_DECOMMIT

	PUSH offset szFilePacked
	CALL _show_log_message

	INVOKE MapFile,addr szOpenFileName

	MOV EAX,FileSize
	MOV PackedSize,EAX
	PUSH EAX
	PUSH offset PSize_format
	PUSH offset buffer
	CALL wsprintf
	ADD ESP,0Ch
	PUSH 604
	PUSH DWORD PTR DS:[HW]
	CALL GetDlgItem
	PUSH offset buffer
	PUSH EAX
	CALL SetWindowText

	INVOKE UnmapFile

	MOV Ratio,0

	FILD PackedSize
	FILD OriginalSize
	FDIV ST(1),ST(0)
	FILD Hundred
	FMUL ST(0),ST(2)
	FIST Ratio

	PUSH Ratio
	PUSH offset Ratio_format
	PUSH offset buffer
	CALL wsprintf
	ADD ESP,0Ch
	PUSH 605
	PUSH DWORD PTR DS:[HW]
	CALL GetDlgItem
	PUSH offset buffer
	PUSH EAX
	CALL SetWindowText
 ERROR_EXIT:

	PUSH offset szPackEnded
	CALL _show_log_message

	MOV ThreadRunning,0
	.if CmdLineTerminate == 1
		INVOKE ExitProcess,NULL
	.endif

	POPAD
	RET
;
; Kraj packera
;------------------------------------------------------------------
; Predefinisane funkcije
;------------------------------------------------------------------
IsDLLNameAdded proc dwDLLName:DWORD,dwHashList:DWORD
	LOCAL Return :DWORD
	PUSHAD

	MOV Return,1
	INVOKE lstrlen,dwDLLName
	MOV ECX,EAX
	MOV EAX,dwDLLName
	XOR EBX,EBX
	CDQ
	.while ECX > 0
		MOV DL,BYTE PTR[EAX]
		.if DL >= "A" && DL <= "Z"
			ADD DL,32
		.endif
		ROL EBX,7
		XOR BL,DL
		INC EAX
		DEC ECX
	.endw
	
	MOV ESI,dwHashList
	.while DWORD PTR[ESI] != 0 && DWORD PTR[ESI] != EBX
		ADD ESI,4
	.endw
	.if DWORD PTR[ESI] != EBX
		MOV DWORD PTR[ESI],EBX
	.else
		DEC Return
	.endif

	POPAD
	MOV EAX,Return
	RET
IsDLLNameAdded endp
;------------------------------------------------------------------
CompressRelocations proc dwRelocationOffset:DWORD,dwRelocationSize:DWORD
	LOCAL dwLastRelocPlace :DWORD
	LOCAL dwCompressedReloc :DWORD
	LOCAL dwCompressedRelocPos :DWORD
	LOCAL dwCompressedRelocBase :DWORD
	LOCAL dwThisRelocationSize :DWORD
 	PUSHAD
 	MOV dwCompressedReloc,0
	MOV ESI,dwRelocationOffset
	.if ESI != 0
		INVOKE VirtualAlloc,NULL,dwRelocationSize,MEM_COMMIT,PAGE_EXECUTE_READWRITE
		MOV dwCompressedReloc,EAX
		MOV dwCompressedRelocPos,EAX
		MOV EDI,ImageBase
		.while DWORD PTR[ESI] != 0
			MOV EDX,DWORD PTR[ESI]
			MOV EAX,DWORD PTR[ESI+4]
			MOV dwThisRelocationSize,EAX
			ADD dwThisRelocationSize,ESI

			MOV EAX,dwCompressedRelocPos
			MOV DWORD PTR[EAX],EDX
			MOV DWORD PTR[EAX+4],8
			MOV dwCompressedRelocBase,EAX
			ADD dwCompressedRelocBase,4
			ADD dwCompressedRelocPos,8
		 	MOV dwLastRelocPlace,-1

;			ADD ESI,8
			INVOKE SortRelocations,ESI,DWORD PTR[ESI+4]
			.while DWORD PTR[ESI] != NULL;ESI < dwThisRelocationSize
				MOVZX EAX,WORD PTR[ESI]
				.if EAX != NULL
					MOV EBX,EAX
					SHR EBX,12
					MOV ECX,EBX
					IMUL EBX,1000h
					SUB EAX,EBX
					ADD EAX,EDX
					ADD EAX,ImageBase
					MOV EBX,EAX
					INVOKE ConvertVA2FO,FileMapVA,EAX
					ADD EAX,FileMapVA
					.if ECX == 3
	;					SUB DWORD PTR[EAX],EDI
						SUB EBX,ImageBase
						MOV ECX,EBX
						SUB EBX,EDX
						.if dwLastRelocPlace != -1
							ADD EBX,EDX
							MOV EAX,EBX
							SUB EBX,dwLastRelocPlace
							MOV dwLastRelocPlace,EAX
							.if EBX < 0E0h
								MOV EAX,dwCompressedRelocPos
								MOV BYTE PTR[EAX],BL
								INC dwCompressedRelocPos
								MOV EAX,dwCompressedRelocBase
								INC DWORD PTR[EAX]
							.else
								ADD BX,0E000h
								XCHG BL,BH
								MOV EAX,dwCompressedRelocPos
								MOV WORD PTR[EAX],BX
								ADD dwCompressedRelocPos,2
								MOV EAX,dwCompressedRelocBase
								ADD DWORD PTR[EAX],2
							.endif
						.else
							MOV dwLastRelocPlace,ECX
							.if EBX < 0E0h
								MOV EAX,dwCompressedRelocPos
								MOV BYTE PTR[EAX],BL
								INC dwCompressedRelocPos
								MOV EAX,dwCompressedRelocBase
								INC DWORD PTR[EAX]
							.else
								ADD BX,0E000h
								XCHG BL,BH
								MOV EAX,dwCompressedRelocPos
								MOV WORD PTR[EAX],BX
								ADD dwCompressedRelocPos,2
								MOV EAX,dwCompressedRelocBase
								ADD DWORD PTR[EAX],2
							.endif
						.endif
					.endif
				.endif
				ADD ESI,2
			.endw
			MOV ESI,dwThisRelocationSize
		.endw
	.endif
	POPAD
	MOV EAX,dwCompressedReloc
	MOV EBX,dwCompressedRelocPos
	ADD EBX,4
	SUB EBX,EAX
	RET
CompressRelocations endp
;------------------------------------------------------------------
SortRelocations proc dwArrayStart:DWORD,dwArraySize:DWORD
	PUSHAD

	INVOKE RtlZeroMemory,addr tmpRelocations,2000h
	MOV EBX,dwArrayStart
	ADD EBX,8
	MOV ECX,dwArraySize
	SUB ECX,8
	INVOKE RtlMoveMemory,addr tmpRelocations,EBX,ECX

	MOV ESI,offset tmpRelocations
	MOV EAX,dwArraySize
	SUB EAX,8
	CDQ
	MOV ECX,2
	DIV ECX
	MOV ECX,EAX
	MOV dwArraySize,ECX
	.while ECX > 0
		MOV EDX,ECX
		MOV EDI,offset tmpRelocations
		MOV EAX,dwArraySize
		IMUL EAX,2
		ADD EDI,EAX
		MOV EAX,ECX
		IMUL EAX,2
		SUB EDI,EAX
		MOVZX EBX,WORD PTR[ESI]
		.while EDX > 0
			.if WORD PTR[EDI] < BX && WORD PTR[EDI] != NULL
				MOVZX EAX,WORD PTR[EDI]
				MOVZX EBX,WORD PTR[ESI]
				MOV WORD PTR[ESI],AX
				MOV WORD PTR[EDI],BX
				MOVZX EBX,WORD PTR[ESI]
			.endif
			ADD EDI,2
			DEC EDX
		.endw
		ADD ESI,2
		DEC ECX
	.endw

	POPAD
	MOV ESI,offset tmpRelocations
	RET
SortRelocations endp
;------------------------------------------------------------------
FilterCode proc dwVirtual:DWORD,dwOffset:DWORD,dwSize:DWORD
	LOCAL TotalImageSize :DWORD
	PUSHAD

	MOV EAX,ImageBase
	ADD EAX,SizeOfImage
	MOV TotalImageSize,EAX
	.data
		FilterCodeTable db 256 dup(0)
		FilterByte dd 0
	.code
	MOV FilterByte,0
	INVOKE RtlZeroMemory,addr FilterCodeTable,256

	MOV ESI,dwOffset
	MOV EDI,dwVirtual
	MOV ECX,dwSize
	.while ECX > 0
		.if BYTE PTR[ESI] == 0E8h || BYTE PTR[ESI] == 0E9h
		       MOV EAX,DWORD PTR[ESI+1]
		       ADD EAX,EDI
		       ADD EAX,5
		       .if EAX < ImageBase || EAX > TotalImageSize
				MOVZX EBX,BYTE PTR[ESI+1]
				LEA EAX,DWORD PTR[FilterCodeTable]
				LEA EAX,DWORD PTR[EAX+EBX]
				MOV BYTE PTR[EAX],1
		       .endif
		       ADD ESI,4
		       ADD EDI,4
		       SUB ECX,4
		.endif
		INC EDI
		INC ESI
		DEC ECX
	.endw

	LEA EAX,DWORD PTR[FilterCodeTable+1]
	XOR ECX,ECX
	.while ECX < 255
		INC ECX
		.if BYTE PTR[EAX] == NULL
			MOV BYTE PTR[FilterByte],CL
			.break
		.endif
		INC EAX
	.endw

	.if DWORD PTR[FilterByte] != 0
		MOV EDI,dwVirtual
		MOV ESI,dwOffset
		MOV ECX,dwSize
		.while ECX > 0
			.if BYTE PTR[ESI] == 0E8h || BYTE PTR[ESI] == 0E9h
			       MOV EAX,DWORD PTR[ESI+1]
			       ADD EAX,EDI
			       SUB EAX,dwVirtual
			       ADD EAX,5
			       BSWAP EAX
			       .if AL == NULL
				       MOV AL,BYTE PTR[FilterByte]
				       MOV DWORD PTR[ESI+1],EAX
				.endif
			       ADD ESI,4
			       ADD EDI,4
			       SUB ECX,4
			.endif
			INC EDI
			INC ESI
			DEC ECX
		.endw
	.else
		MOV ESI,dwOffset
		CDQ
		MOV ECX,dwSize
		.while ECX > 0
			INC EDX
			.if BYTE PTR[ESI] == 0E8h || BYTE PTR[ESI] == 0E9h
			       MOV EAX,DWORD PTR[ESI+1]
			       ADD EAX,EDX
			       BSWAP EAX
			       MOV DWORD PTR[ESI+1],EAX
			       ADD ESI,4
			       ADD EDX,4
			       SUB ECX,4
			.endif
			INC ESI
			DEC ECX
		.endw
	.endif

	POPAD
	RET
FilterCode endp
;------------------------------------------------------------------
CompressSection PROC inDestionation:DWORD,inSource:DWORD,inSize:DWORD
	LOCAL CompressedSize :DWORD
	LOCAL CompressedMem :DWORD
	LEA EAX,DWORD PTR[CompressedSize]

	PUSH offset lProgress
	PUSH EAX
	PUSH inSize
	PUSH inSource
	CALL DWORD PTR[hCompress]
	.if EAX == 0
		MOV CompressedSize,-1
	.endif

	MOV CompressedMem,EAX
	INVOKE RtlMoveMemory,inDestionation,CompressedMem,CompressedSize
	PUSH CompressedMem
	CALL DWORD PTR[hFreeCompressionMemory]

	MOV EAX,CompressedSize
	RET
CompressSection ENDP
;------------------------------------------------------------------
lProgress PROC dwPercent:DWORD
	LOCAL hwndProgress :DWORD
	PUSHAD

	MOV EAX,dwPercent
	.if EAX > LastRatio
		MOV LastRatio,EAX
	        INVOKE GetDlgItem,HW,900
	        MOV hwndProgress,EAX
	        INVOKE SendMessage,hwndProgress,PBM_SETPOS,LastRatio,0
	.endif

	POPAD
	XOR EAX,EAX
	MOV AL,1
	RET
lProgress ENDP
;------------------------------------------------------------------
GetSectionNumber PROC fMap:DWORD,fAddr:DWORD
	LOCAL Converted :DWORD
	LOCAL fSecNumber :DWORD
	PUSHAD
 ;
 ; Konverzija
 ;
	MOV EAX,fMap		; Parametar 1 = FileMapVA
	MOV EBX,fAddr		; Parametar 2 = Adresa za konverziju
	SUB EBX,DWORD PTR[ImageBase]
 ;
 ; elfa_new
 ;
	XOR ECX,ECX
	MOV CX,WORD PTR[EAX+3Ch]
 ;
 ; PEHeader
 ;
	LEA ECX,DWORD PTR[EAX+ECX]
	MOV EAX,ECX
 ;
 ; NumberOfSections
 ;
	XOR ECX,ECX
	MOV CX,WORD PTR[EAX+6]
	MOV fSecNumber,ECX
 ;
 ; Section Tabela
 ;
	ADD AX,WORD PTR[EAX+14h]
	ADD EAX,018h
	.while ECX > 0
		MOV EDX,DWORD PTR[EAX+8]
		MOV EDI,DWORD PTR[EAX+12]
		.if EBX >= EDI
			ADD EDI,EDX
			.if EBX < EDI
				SUB ECX,fSecNumber
				NEG ECX
				INC ECX
				MOV EBX,ECX
				MOV ECX,1
			.endif
		.endif
		ADD EAX,28h
		DEC ECX
	.endw
	MOV DWORD PTR[Converted],EBX
 ; 
 ; Izlaz iz konverzije
 ;
	POPAD
	MOV EAX,DWORD PTR[Converted]
	RET
GetSectionNumber ENDP
;------------------------------------------------------------------
ExtractOverlay proc szFname:DWORD,szSaveFileName:DWORD
	LOCAL Return :DWORD
	PUSHAD
	MOV Return,0
	MOV FileMapVA,0
	INVOKE MapFile,szFname

	.if FileMapVA != 0
		MOV EAX,FileMapVA
		ADD EAX,3Ch
		ADD AX,WORD PTR[EAX]		;WinME/98/95 compatibility!
		SUB AX,3Ch			;
		MOV PEHeader,EAX
		MOVZX EBX,WORD PTR[EAX+6h]
		MOV NumberOfSections,EBX
		ADD AX,WORD PTR[EAX+14h]
		ADD EAX,18h
		MOV ECX,NumberOfSections
		DEC ECX
		IMUL ECX,28h
		ADD EAX,ECX
		ADD EAX,8
	
		MOV EBX,DWORD PTR[EAX+8]
		MOV RawSize,EBX
		MOV EBX,DWORD PTR[EAX+12]
		MOV RawOffset,EBX
	
		XOR EAX,EAX
		ADD EAX,RawOffset
		ADD EAX,RawSize
		.if EAX < FileSize
			MOV EBX,FileSize
			SUB EBX,EAX
			ADD EAX,FileMapVA
			MOV eStart,EAX
			MOV eSize,EBX
	
			INVOKE CreateFile,szSaveFileName,GENERIC_WRITE,NULL,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
			MOV hSaveFile,EAX
			INVOKE WriteFile,hSaveFile,eStart,eSize,addr NumberOfBytesWritten,NULL
			INVOKE CloseHandle,hSaveFile
			MOV EAX,eSize
			MOV Return,EAX	;Size of extracted file
		.else
			MOV Return,0h	;No overlay
		.endif
	.else
		MOV Return,-1		;Could not map file
	.endif

	INVOKE UnmapFile
	POPAD
	MOV EAX,Return
	RET
ExtractOverlay endp
;------------------------------------------------------------------
AddOverlay proc szFname:DWORD,szOvlFName:DWORD
	LOCAL Return :DWORD
	LOCAL CopyAlloc :DWORD
	LOCAL CopySize :DWORD
	LOCAL CopyStart :DWORD
	PUSHAD
	MOV Return,0
	MOV FileMapVA,0
	INVOKE MapFile,szOvlFName

	.if FileMapVA != 0
		MOV EAX,FileSize
		MOV CopySize,EAX
		INVOKE VirtualAlloc,NULL,CopySize,MEM_COMMIT,PAGE_READWRITE
		MOV CopyAlloc,EAX
		INVOKE RtlMoveMemory,CopyAlloc,FileMapVA,CopySize
		INVOKE UnmapFile

               	INVOKE MapFile,szFname
		MOV EAX,FileSize
               	MOV CopyStart,EAX
		INVOKE UnmapFile

		INVOKE ResizeMapFile,szFname,CopySize
		MOV EAX,FileMapVA
		ADD CopyStart,EAX
		INVOKE RtlMoveMemory,CopyStart,CopyAlloc,CopySize
		INVOKE UnmapFile

		INVOKE VirtualFree,CopyAlloc,CopySize,MEM_DECOMMIT
		MOV Return,1		;Success
	.else
		MOV Return,0		;Could not map file
	.endif

	POPAD
	MOV EAX,Return
	RET
AddOverlay endp
;------------------------------------------------------------------
initProgress PROC
	LOCAL hwndProgress :DWORD
	PUSHAD
	MOV LastRatio,0
        INVOKE GetDlgItem,HW,900
        MOV hwndProgress,EAX
        INVOKE SendMessage,hwndProgress,PBM_SETPOS,LastRatio,0
	POPAD
	RET
initProgress ENDP
;------------------------------------------------------------------
cProgress PROC C inLen:DWORD,inCompressed:DWORD,outCompressed:DWORD,Cparam:DWORD
	LOCAL hwndProgress :DWORD
	PUSHAD

	MOV EAX,inCompressed
	CDQ
	MOV ECX,100
	IMUL ECX
	DIV inLen

	.if EAX > LastRatio
		MOV LastRatio,EAX
	        INVOKE GetDlgItem,HW,900
	        MOV hwndProgress,EAX

	        INVOKE SendMessage,hwndProgress,PBM_SETPOS,LastRatio,0
	.endif

	POPAD
	MOV EAX,1
	RET
cProgress ENDP
;------------------------------------------------------------------
FindMainIcon PROC

	LOCAL fRSRC1	:DWORD
	LOCAL pRSRC1	:DWORD

	PUSHAD
	MOV EBX,FileMapVA
	ADD EBX,3Ch
	ADD BX,WORD PTR[EBX]		;WinME/98/95 compatibility!
	SUB BX,3Ch			;

	MOV EAX,DWORD PTR[EBX+88h]
	MOV EBX,DWORD PTR[EBX+8Ch]
	PUSHAD

	ADD EAX,ImageBase
	INVOKE ConvertVA2FO,FileMapVA,EAX
	MOV fRSRC1,EAX
	ADD EAX,FileMapVA
	MOV pRSRC1,EAX

	POPAD
	.if EAX != 0
		MOV EAX,pRSRC1

		MOVZX EBX,WORD PTR[EAX+12]
		ADD BX,WORD PTR[EAX+14]
		MOV Level1_CNT,EBX
		ADD EAX,16
		.while Level1_CNT > 0
			MOV EBX,DWORD PTR[EAX]
			MOV pType,EBX
			MOV EBX,DWORD PTR[EAX+4]
			XOR EBX,80000000h
			ADD EBX,pRSRC1
			MOVZX ECX,WORD PTR[EBX+12]
			ADD CX,WORD PTR[EBX+14]
			MOV Level2_CNT,ECX
			ADD EBX,16
                        .while Level2_CNT > 0
				MOV ECX,DWORD PTR[EBX]
				MOV pName,ECX
				MOV ECX,DWORD PTR[EBX+4]
				XOR ECX,80000000h
				ADD ECX,pRSRC1
				MOVZX EDX,WORD PTR[ECX+12]
				ADD DX,WORD PTR[ECX+14]
				MOV Level3_CNT,EDX
				ADD ECX,16
				.while Level3_CNT > 0
					MOV EDX,DWORD PTR[ECX+4]
					ADD EDX,pRSRC1
					MOV EDI,DWORD PTR[EDX]
					MOV pDataRVA,EDI
					MOV EDI,DWORD PTR[EDX+4]
					MOV pSize,EDI

					.if oStripRSRC == 0 && pType == 10h
						MOV pType,0h
					.endif
					.if pType == 03h || pType == 10h || pType == 0Eh || pType == 18h || rPack == 1
						PUSHAD
						MOV EAX,pDataRVA
						ADD EAX,ImageBase
						INVOKE ConvertVA2FO,FileMapVA,EAX
						ADD EAX,pRSRC1
						SUB EAX,fRSRC1
						.if pType == 0Eh && MAIN_ICON == 0
							PUSHAD
							MOV EDI,EAX
							INVOKE IsBadReadPtr,EDI,4
							.if EAX == NULL
								MOVZX EAX,BYTE PTR[EDI+4]
								MOV MAIN_ICON_SIZE,EAX
								MOV MAIN_ICON_COUNT,EAX
								.if pSize >= 13h
									MOV AX,WORD PTR[EDI+12h]
									MOV MAIN_ICON,EAX
									ADD MAIN_ICON_SIZE,EAX
								.endif
							.else
								MOV MAIN_ICON,-1
							.endif
							POPAD
						.endif
						POPAD
					.endif

					ADD ECX,8
					DEC Level3_CNT
				.endw
				ADD EBX,8
				DEC Level2_CNT
                        .endw
			ADD EAX,8
			DEC Level1_CNT
		.endw
	.endif
	POPAD
	RET
FindMainIcon ENDP
;------------------------------------------------------------------
RSRCPack PROC
	LOCAL fRSRC	:DWORD
	LOCAL sRSRC	:DWORD
	LOCAL SizeOfRSRC :DWORD
	LOCAL SkipRSRCpk :DWORD

	PUSHAD
	MOV SkipRSRCpk,0
	MOV pFirst,1
	PUSH MAIN_ICON_COUNT
	MOV EBX,FileMapVA
	ADD EBX,3Ch
	ADD BX,WORD PTR[EBX]		;WinME/98/95 compatibility!
	SUB BX,3Ch			;

	MOV EAX,DWORD PTR[EBX+88h]
	MOV EBX,DWORD PTR[EBX+8Ch]
	MOV SizeOfRSRC,EBX
	PUSH EAX
	PUSH EBX
	INVOKE VirtualAlloc,NULL,EBX,MEM_COMMIT,PAGE_EXECUTE_READWRITE
	MOV pRSRC,EAX
	POP EBX
	POP EAX
	PUSHAD

	ADD EAX,ImageBase
	INVOKE ConvertVA2FO,FileMapVA,EAX
	MOV fRSRC,EAX
	ADD SizeOfRSRC,EAX
	ADD EAX,FileMapVA

	INVOKE RtlMoveMemory,pRSRC,EAX,EBX
	POPAD
	.if EAX != 0
		PUSH EBX
		MOV EAX,pRSRC

		MOVZX EBX,WORD PTR[EAX+12]
		ADD BX,WORD PTR[EAX+14]
		MOV Level1_CNT,EBX
		ADD EAX,16
		.while Level1_CNT > 0
			MOV EBX,DWORD PTR[EAX]
			MOV pType,EBX
			MOV EBX,DWORD PTR[EAX+4]
			XOR EBX,80000000h
			ADD EBX,pRSRC
			MOVZX ECX,WORD PTR[EBX+12]
			ADD CX,WORD PTR[EBX+14]
			MOV Level2_CNT,ECX
			ADD EBX,16
                        .while Level2_CNT > 0
				MOV ECX,DWORD PTR[EBX]
				MOV pName,ECX
				.if pFirst == 1
					PUSHAD
					MOV ECX,DWORD PTR[EBX]
					.if ECX > 80000000h
						XOR ECX,80000000h
						ADD ECX,pRSRC
						.if BYTE PTR[ECX] != NULL
							.while BYTE PTR[ECX] != NULL
								ADD ECX,2
							.endw
							MOV pFirst,2
							SUB ECX,pRSRC
							MOV RSRCSize,ECX
						.endif
					.endif
					POPAD
				.endif
				MOV ECX,DWORD PTR[EBX+4]
				XOR ECX,80000000h
				ADD ECX,pRSRC
				MOVZX EDX,WORD PTR[ECX+12]
				ADD DX,WORD PTR[ECX+14]
				MOV Level3_CNT,EDX
				ADD ECX,16
				.while Level3_CNT > 0
					MOV EDX,DWORD PTR[ECX+4]
					ADD EDX,pRSRC
					MOV EDI,DWORD PTR[EDX]
					MOV pDataRVA,EDI
					MOV EDI,DWORD PTR[EDX+4]
					MOV pSize,EDI

					.if pFirst == 1
						MOV pFirst,0
						PUSHAD
						MOV EAX,pDataRVA
						ADD EAX,ImageBase
						INVOKE ConvertVA2FO,FileMapVA,EAX
						.if EAX < SizeOfRSRC
							SUB EAX,fRSRC
							MOV EBX,EAX
							ROL EBX,8
							.if BL < 7Fh
								MOV sRSRC,EAX
							.else
								INC pFirst
							.endif
						.else
							INC SkipRSRCpk
							MOV rPack,-1
						.endif
						POPAD
					.elseif pFirst == 2
						MOV pFirst,0
						PUSHAD
						MOV EAX,RSRCSize
						MOV sRSRC,EAX
						POPAD
					.endif
					PUSHAD
					MOV EAX,pDataRVA
					ADD EAX,ImageBase
					INVOKE ConvertVA2FO,FileMapVA,EAX
					SUB EAX,fRSRC
					MOV EBX,EAX
					ROL EBX,8
					.if BL < 7Fh
						.if EAX < sRSRC
							MOV sRSRC,EAX
						.endif
					.endif
					POPAD
					PUSHAD
					.if rPack != -1
						MOV rPack,0
						MOV EAX,pType
						MOV EBX,offset rawbuffer
						.while DWORD PTR[EBX] != 0
							.if DWORD PTR[EBX] == EAX
								MOV rPack,1
							.endif
							ADD EBX,4
						.endw
					.endif
					POPAD
					.if (pType == 03h && MAIN_ICON_COUNT > 0) || rPack == 1 && rPack != -1
						PUSHAD
						MOV EAX,MAIN_ICON
						MOV EBX,MAIN_ICON_SIZE
						.if pName >= EAX && pName <= EBX
							DEC MAIN_ICON_COUNT
							MOV EAX,pDataRVA
							ADD EAX,ImageBase
							INVOKE ConvertVA2FO,FileMapVA,EAX
							ADD EAX,pRSRC
							SUB EAX,fRSRC
							MOV ESI,EAX
							INVOKE IsBadReadPtr,ESI,pSize
							.if EAX == NULL
								INVOKE RtlZeroMemory,ESI,pSize
							.endif
						.endif
						POPAD
					.endif
					.if pType == 10h || pType == 0Eh || pType == 18h || rPack == 1 && rPack != -1
						PUSHAD
						MOV DWORD PTR[EDX],0
						MOV DWORD PTR[EDX+4],0
						MOV DWORD PTR[EBX],0
						MOV DWORD PTR[EBX+4],0
						MOV DWORD PTR[EAX],0
						MOV DWORD PTR[EAX+4],0
						MOV EAX,pDataRVA
						ADD EAX,ImageBase
						INVOKE ConvertVA2FO,FileMapVA,EAX
						ADD EAX,pRSRC
						SUB EAX,fRSRC
						MOV ESI,EAX
						INVOKE IsBadReadPtr,ESI,pSize
						.if EAX == NULL
							INVOKE RtlZeroMemory,ESI,pSize
						.endif
						POPAD
					.endif
					ADD ECX,8
					DEC Level3_CNT
				.endw
				ADD EBX,8
				DEC Level2_CNT
                        .endw
			ADD EAX,8
			DEC Level1_CNT
		.endw
		POP EBX
		MOV pSize,EBX
		MOV EAX,pRSRC
		.if SkipRSRCpk == NULL
			MOV CompressSectionOffset,EAX
			INVOKE RtlZeroMemory,pRSRC,sRSRC
		.endif
	.endif
	POP MAIN_ICON_COUNT
	POPAD
	RET
RSRCPack ENDP
;------------------------------------------------------------------
FixPackedHeader:
	MOV EAX,PEHeader
	ADD AX,WORD PTR[EAX+14h]
	ADD EAX,18h
	MOV ECX,SizeOfImage
	MOV DWORD PTR[EAX+8],ECX
	ADD EAX,28h
	ADD ECX,1000h
	PUSH ECX
	MOV DWORD PTR[EAX+12],ECX
	MOV ECX,hPackedFilePos
	SUB ECX,hPackedFileBuff
	SUB ECX,200h
	PUSH ECX
	MOV DWORD PTR[EAX+8],ECX
	MOV DWORD PTR[EAX+16],ECX
	MOV ECX,200h
	MOV DWORD PTR[EAX+20],ECX
	POP EDX
	POP ECX
	ADD ECX,EDX
	MOV EAX,PEHeader
	MOV DWORD PTR[EAX+50h],ECX
	RET
;------------------------------------------------------------------
WriteData PROC CopyOffset:DWORD,CopySize:DWORD
	PUSHAD

	INVOKE RtlMoveMemory,hPackedFilePos,CopyOffset,CopySize
	MOV EAX,CopySize
	ADD hPackedFilePos,EAX

	POPAD
	RET
WriteData ENDP
;------------------------------------------------------------------
IsSectionPackable PROC SectionAttributes:DWORD,SectionName:DWORD
	LOCAL Compare :DWORD
	PUSHAD
	MOV Compare,0
	MOV EAX,SectionAttributes

	TEST EAX,10000000h
	JE _not_shareable
		MOV Shareable,1
	_not_shareable:
	TEST EAX,20000000h
	JE _not_executable
		MOV Compare,1
	_not_executable:
	MOV EAX,SectionAttributes
	TEST EAX,40000000h
	JE _not_readable
		MOV Compare,1
	_not_readable:
	MOV EAX,SectionAttributes
	TEST EAX,80000000h
	JE _not_writable
		MOV Compare,1
	_not_writable:
	MOV EAX,SectionAttributes
	TEST EAX,00000040h
	JE _not_initalized
		MOV Compare,1
	_not_initalized:
	MOV EAX,SectionAttributes
	TEST EAX,00000080h
	JE _not_uninitialized
		MOV Compare,1
	_not_uninitialized:
	MOV EAX,SectionAttributes
	TEST EAX,02000000h
	JE _not_discarable
		.if oStripReloc == 1 && IsDll == 0
			MOV Compare,2
		.else
			MOV Compare,1
		.endif
	_not_discarable:
	INVOKE lstrcmp,SectionName,addr szSN_reloc
	.if EAX == 0 && oStripReloc == 1 && IsDll == 0
		MOV Compare,2
	.elseif EAX == 0 && oStripReloc == 0 && IsDll == 1
		MOV Compare,4
	.elseif EAX == 0 && IsDll == 1
		MOV Compare,4
	.endif
	INVOKE lstrcmp,SectionName,addr szSN_tls
	.if EAX == 0
		MOV Compare,2
	.endif

	POPAD
	MOV EAX,Compare
	RET
IsSectionPackable ENDP
;------------------------------------------------------------------
ConvertVA2FO PROC fMap:DWORD,fAddr:DWORD

	LOCAL Converted :DWORD

	PUSHAD
 ;
 ; Konverzija
 ;
	MOV EAX,fMap		; Parametar 1 = FileMapVA
	MOV EBX,fAddr		; Parametar 2 = Adresa za konverziju
	SUB EBX,DWORD PTR[ImageBase]
 ;
 ; elfa_new
 ;
	XOR ECX,ECX
	MOV CX,WORD PTR[EAX+3Ch]
 ;
 ; PEHeader
 ;
	LEA ECX,DWORD PTR[EAX+ECX]
	MOV EAX,ECX
 ;
 ; NumberOfSections
 ;
	XOR ECX,ECX
	MOV CX,WORD PTR[EAX+6]
 ;
 ; Section Tabela
 ;
	ADD AX,WORD PTR[EAX+14h]
	ADD EAX,018h
	.while ECX > 0
		MOV EDX,DWORD PTR[EAX+8]
		MOV EDI,DWORD PTR[EAX+12]
		.if EBX >= EDI
			.if EDX == NULL
				MOV EDX,DWORD PTR[EAX+16]
			.endif
			ADD EDI,EDX
			.if EBX < EDI
				MOV ECX,1
				SUB EBX,EDI
				ADD EBX,EDX
				ADD EBX,DWORD PTR[EAX+20]
;				ADD EBX,DWORD PTR[EBP+8]
			.endif
		.endif
	ADD EAX,28h
	DEC ECX
	.endw
	MOV DWORD PTR[Converted],EBX
 ; 
 ; Izlaz iz konverzije
 ;
	POPAD
	MOV EAX,DWORD PTR[Converted]
	RET
ConvertVA2FO ENDP
;------------------------------------------------------------------
ConvertFO2VA PROC fMap:DWORD,fAddr:DWORD

	LOCAL Converted :DWORD

	PUSHAD
 ; 
 ; Konverzija
 ;
	MOV EAX,fMap		; Parametar 1 = FileMapVA
	MOV EBX,fAddr		; Parametar 2 = Adresa za konverziju
	SUB EBX,EAX
 ;
 ; elfa_new
 ;
	XOR ECX,ECX
	MOV CX,WORD PTR[EAX+3Ch]
 ;
 ; PEHeader
 ;
	LEA ECX,DWORD PTR[EAX+ECX]
	MOV EAX,ECX
 ;
 ; NumberOfSections
 ;
	XOR ECX,ECX
	MOV CX,WORD PTR[EAX+6]
 ;
 ; Section Tabela
 ;
	ADD AX,WORD PTR[EAX+14h]
	ADD EAX,018h
	.while ECX > 0
		MOV EDX,DWORD PTR[EAX+16]
		MOV EDI,DWORD PTR[EAX+20]
		.if EBX >= EDI
			ADD EDI,EDX
			.if EBX <= EDI
				MOV ECX,1
				SUB EBX,EDI
				ADD EBX,EDX
				ADD EBX,DWORD PTR[EAX+12]
;				ADD EBX,DWORD PTR[ImageBase]
			.endif
		.endif
	ADD EAX,28h
	DEC ECX
	.endw
	MOV DWORD PTR[Converted],EBX
 ; 
 ; Izlaz iz konverzije
 ;
	POPAD
	MOV EAX,DWORD PTR[Converted]
	RET
ConvertFO2VA ENDP
;------------------------------------------------------------------
GetExeFile PROC
	PUSHAD

        INVOKE GetModuleHandle,NULL
        MOV DWORD PTR[hInstance],EAX

	PUSH 260
	PUSH offset buffer
	CALL RtlZeroMemory

	MOV ofn.lStructSize,SIZEOF ofn
	MOV ofn.lpstrFilter, OFFSET FilterString
	MOV ofn.lpstrFile, OFFSET buffer
	MOV ofn.nMaxFile,512
	MOV ofn.Flags, OFN_FILEMUSTEXIST or \
			OFN_PATHMUSTEXIST or OFN_LONGNAMES or\
			OFN_EXPLORER or OFN_HIDEREADONLY
	MOV  ofn.lpstrTitle, OFFSET OurTitle
	INVOKE GetOpenFileName, ADDR ofn

	INVOKE lstrcpy,addr szOpenFileName,addr buffer
	INVOKE lstrcpy,addr szPackedFileName,addr buffer
	INVOKE lstrcat,addr szPackedFileName,addr szPackedExe

	POPAD
	RET
GetExeFile ENDP
;------------------------------------------------------------------
CreateOutFile PROC fName:DWORD
	PUSHAD
	INVOKE CreateFile,fName,GENERIC_WRITE,NULL,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
	.if EAX == -1
		INVOKE MessageBox,NULL,addr szErrorText,addr szErrorTitle,30h
		INVOKE ExitProcess,NULL
	.endif
	MOV DWORD PTR[hPackedFile],EAX
	POPAD
	RET
CreateOutFile ENDP
;------------------------------------------------------------------
CloseOutFile PROC
	PUSHAD
        INVOKE CloseHandle,DWORD PTR[hPackedFile]
	POPAD
	RET
CloseOutFile ENDP
;------------------------------------------------------------------
MapFile PROC fName:DWORD
	PUSHAD
	INVOKE CreateFile,DWORD PTR[EBP+8],GENERIC_READ+GENERIC_WRITE,NULL,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
	.if EAX == -1
		.if CmdLineNoMSGs == NULL
			INVOKE MessageBox,NULL,addr szErrorText,addr szErrorTitle,30h
		.endif
		POPAD
		RET
	.endif
	MOV DWORD PTR[FileHWND],EAX
	INVOKE GetFileSize,DWORD PTR[FileHWND],NULL
	MOV DWORD PTR[FileSize],EAX
	INVOKE CreateFileMapping,DWORD PTR[FileHWND],NULL,4,NULL,DWORD PTR[FileSize],NULL
	MOV DWORD PTR[FileMap],EAX
	INVOKE MapViewOfFile,DWORD PTR[FileMap],2,NULL,NULL,NULL
	MOV DWORD PTR[FileMapVA],EAX
	POPAD
	RET
MapFile ENDP
;------------------------------------------------------------------
UnmapFile PROC
	PUSHAD
	INVOKE UnmapViewOfFile,DWORD PTR[FileMapVA]
	INVOKE CloseHandle,DWORD PTR[FileMap]
	INVOKE SetFilePointer,DWORD PTR[FileHWND],DWORD PTR[FileSize],NULL,NULL
	INVOKE SetEndOfFile,DWORD PTR[FileHWND]
	INVOKE CloseHandle,DWORD PTR[FileHWND]
	POPAD
	RET
UnmapFile ENDP
;------------------------------------------------------------------
ResizeMapFile PROC fName:DWORD,fSize:DWORD
	PUSHAD
	INVOKE CreateFile,DWORD PTR[EBP+8],GENERIC_READ+GENERIC_WRITE,NULL,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
	.if EAX == -1
		POPAD
		RET
	.endif
	MOV DWORD PTR[FileHWND],EAX
	INVOKE GetFileSize,DWORD PTR[FileHWND],NULL
	MOV DWORD PTR[FileSize],EAX
	MOV EAX,DWORD PTR[EBP+12]
	ADD DWORD PTR[FileSize],EAX
	INVOKE CreateFileMapping,DWORD PTR[FileHWND],NULL,4,NULL,DWORD PTR[FileSize],NULL
	MOV DWORD PTR[FileMap],EAX
	INVOKE MapViewOfFile,DWORD PTR[FileMap],2,NULL,NULL,NULL
	MOV DWORD PTR[FileMapVA],EAX
	POPAD
	RET
ResizeMapFile ENDP
;------------------------------------------------------------------
     _show_log_message:
	PUSH EBP
	MOV EBP,ESP
	PUSHAD
	PUSH [EBP+8]
	PUSH 0
	PUSH 180h
	PUSH [BoxHwnd]
	CALL SendMessage
	PUSH 0
	PUSH 0
	PUSH 18Bh
	PUSH [BoxHwnd]
	CALL SendMessage
	DEC EAX
	PUSH 0
	PUSH EAX
	PUSH 186h
	PUSH [BoxHwnd]
	CALL SendMessage
	POPAD
	LEAVE
	RET 4
;------------------------------------------------------------------
     _show_log_message_2:
	PUSH EBP
	MOV EBP,ESP
	PUSHAD
	PUSH [EBP+8]
	PUSH 0
	PUSH 180h
	PUSH [BoxHwnd]
	CALL SendMessage
	POPAD
	LEAVE
	RET 4
;------------------------------------------------------------------
    _convert_text_2_number:
	PUSH EBP
	MOV EBP,ESP
	PUSH ECX
	PUSH EDX
	PUSH EBX
	PUSH ESI
	PUSH EDI
	MOV EDI,DWORD PTR SS:[EBP+8]
	MOV ESI,DWORD PTR SS:[EBP+8]
    L007:
	MOV AL,BYTE PTR DS:[EDI]
	INC EDI
	OR AL,AL
	JNE L007
	SUB ESI,EDI
	XOR EBX,EBX
	ADD EDI,ESI
	XOR EDX,EDX
	NOT ESI
	JMP L033
    L017:
	MOV AL,BYTE PTR DS:[EDI]
	CMP AL,41h
	JB L025
	SUB AL,57h
	ADC DL,0
	SHL DL,5
	ADD AL,DL
	JMP L026
    L025:
	SUB AL,30h
    L026:
	LEA ECX,DWORD PTR DS:[ESI-1]
	AND EAX,0Fh
	SHL ECX,2
	SHL EAX,CL
	ADD EBX,EAX
	INC EDI
	DEC ESI
    L033:
	OR ESI,ESI
	JNE L017
	MOV EAX,EBX
	POP EDI
	POP ESI
	POP EBX
	POP EDX
	POP ECX
	LEAVE
	RET 4
;------------------------------------------------------------------
	include Stub_aplib.asm
	include Stub_lzma.asm

end start